using System;
using System.Web.UI.WebControls.WebParts;

namespace myControls
{

    /// <summary>
    /// This class transforms an IZIPCode to
    /// an INewsZIPCode
    /// </summary>
    [WebPartTransformer(typeof(IZIPCode), typeof(INewsZIPCode))]
    public class ZIPCodeTransformer : WebPartTransformer
    {
        public override object Transform(object providerData)
        {
            return new TempZIP(((IZIPCode)providerData).ZIPCode);
        }
    }

    public class TempZIP : INewsZIPCode
    {
        private string _zipCode;

        public string ZIPCode
        {
            get { return _zipCode; }
        }

        internal TempZIP(string zipCode)
        {
            _zipCode = zipCode;
        }
    }
}