﻿<%@ Control Language="C#" ClassName="FeaturedBookPart" %>

<script runat="server">

    private string _bookTitle = "Untitled";
    private BookCategory _category = BookCategory.Computers;
    private string _bookDescription;
    private bool _onSale;
    
    public enum BookCategory
    {
        Computers,
        History,
        Mystery
    }

    [Personalizable]
    [WebBrowsable]
    [WebDisplayName("Title")]
    [WebDescription("The title of the book")]
    public string BookTitle
    {
        get { return _bookTitle; }
        set { _bookTitle = value; }
    }

    [Personalizable]
    [WebBrowsable]
    [WebDisplayName("Category")]
    [WebDescription("The category of the book")]
    public BookCategory Category
    {
        get { return _category; }
        set { _category = value; }
    }

    [Personalizable]
    [WebBrowsable]
    [WebDisplayName("Description")]
    [WebDescription("The description of the book")]
    public string BookDescription
    {
        get { return _bookDescription; }
        set { _bookDescription = value; }
    }

    [Personalizable]
    [WebBrowsable]
    [WebDisplayName("On Sale")]
    [WebDescription("Indicates that the book is on sale")]
    public bool OnSale
    {
        get { return _onSale; }
        set { _onSale = value; } 
    }

    void Page_PreRender()
    {
        ltlBookTitle.Text = _bookTitle;
        lblCategory.Text = _category.ToString();
        lblBookDescription.Text = _bookDescription;
        lblOnSale.Visible = _onSale;
    }
    
</script>
<h1 class="bookTitle">
<asp:Literal 
    ID="ltlBookTitle" 
    runat="server"/>
</h1>
<asp:Label 
    ID="lblCategory" 
    CssClass="category"
    runat="server" />
<br />
<asp:Label 
    ID="lblBookDescription" 
    runat="server" />
<br />
<asp:Label 
    ID="lblOnSale"
    Text="On Sale!" 
    Visible="false" 
    CssClass="onSale"
    runat="server" />
