﻿<%@ Control Language="C#" ClassName="FeaturedMoviePart" %>

<script runat="server">

    public enum MovieCategory
    {
        Action,
        Animation,
        Drama,
        Horror
    }

    private string _movieTitle;
    private MovieCategory _category;
    private string _movieDescription;
    private bool _inTheaters;
    
    [Personalizable]
    [WebBrowsable]
    [WebDisplayName("Title")]
    [WebDescription("The title of the movie")]
    public string MovieTitle
    {
        get { return _movieTitle; }
        set { _movieTitle = value; }
    }

    [Personalizable]
    [WebBrowsable]
    [WebDisplayName("Category")]
    [WebDescription("The movie category")]
    public MovieCategory Category
    {
        get { return _category; }
        set { _category = value; }
    }

    [Personalizable]
    [WebBrowsable]
    [WebDisplayName("Description")]
    [WebDescription("The movie description")]
    public string MovieDescription
    {
        get { return _movieDescription; }
        set { _movieDescription = value; }
    }

    [Personalizable]
    [WebBrowsable]
    [WebDisplayName("In Theaters")]
    [WebDescription("Is the movie currently showing?")]
    public bool InTheaters
    {
        get { return _inTheaters; }
        set { _inTheaters = value; }
    }

    void Page_PreRender()
    {
        lblMovieTitle.Text = _movieTitle;
        lblCategory.Text = _category.ToString();
        lblMovieDescription.Text = _movieDescription;
        lblInTheaters.Visible = _inTheaters;
    }
</script>

<div class="featuredMovie">
<asp:Label
    id="lblMovieTitle"
    Runat="server" />
<br />
<asp:Label
    id="lblCategory"
    Runat="server" />    
<br />
<asp:Label
    id="lblMovieDescription"
    Runat="server" />    
<br />
<asp:Label
    id="lblInTheaters"
    Text="In Theaters Now!"
    CssClass="inTheaters"
    Runat="server" />    
</div>