﻿<%@ Control Language="C#" ClassName="MovieListPart" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<script runat="server">

    private IMovieCategory _category;

    /// <summary>
    /// This method is called when the ProvideCategory method
    /// returns a class that implements the IMovieCategory interface
    /// </summary>
    [ConnectionConsumer("Movie Category")]
    public void ConsumeCategory(IMovieCategory category)
    {
        _category = category;
    }

    /// <summary>
    /// Update SelectedCategoryId from Provider Web Part
    /// </summary>
    void Page_PreRender()
    {
        if (_category != null)
        {
            srcMovies.SelectParameters["CategoryId"].DefaultValue = _category.SelectedCategoryId.ToString();
        }
    }

</script>

<asp:GridView
    id="grdMovies"
    DataSourceId="srcMovies"
    Runat="server" />
    
<asp:SqlDataSource
    id="srcMovies"
    ConnectionString="Server=.\SQLExpress;Integrated Security=True;
        AttachDbFileName=|DataDirectory|MyDatabase.mdf;User Instance=True"
    SelectCommand="SELECT Title,Director,YearReleased 
        FROM Movies WHERE CategoryId=@CategoryId"
    Runat="server">
    <SelectParameters>
        <asp:Parameter Name="CategoryId" Type="int32" />
    </SelectParameters>
</asp:SqlDataSource>    
    