﻿<%@ Control Language="C#" ClassName="WeatherPart" %>

<script runat="server">

    private IZIPCode _zipCode;

    /// <summary>
    /// This method retrieves the IZIPCode interface returned
    /// by the ProvideZIPCode method
    /// </summary>
    [ConnectionConsumer("ZIP Code")]
    public void ConsumeZIPCode(IZIPCode zipCode)
    {
        _zipCode = zipCode;
    }
  
    
    /// <summary>
    /// Display the weather
    /// </summary>
    void Page_PreRender()
    {
        /// Check if we are connected
        if (_zipCode != null)
        {
            if (_zipCode.ZIPCode != String.Empty)
                lblWeather.Text = String.Format("The weather for {0} is expected to be sunny!", _zipCode.ZIPCode);
            else
                lblWeather.Text = "Please enter your ZIP code";
        }
    }
    
</script>

<h3>Current Weather</h3>
<asp:Label
    id="lblWeather"
    Runat="server" />