Imports System
Imports System.Web.UI.WebControls.WebParts

Namespace myControls

    ''' <summary>
    ''' This class transforms an IZIPCode to
    ''' an INewsZIPCode
    ''' </summary>
    <WebPartTransformer(GetType(IZIPCode), GetType(INewsZIPCode))> _
    Public Class ZIPCodeTransformer
        Inherits WebPartTransformer
        Public Overrides Function Transform(ByVal providerData As Object) As Object
            Return New TempZIP((CType(providerData, IZIPCode)).ZIPCode)
        End Function
    End Class

    Public Class TempZIP
        Implements INewsZIPCode
        Private _zipCode As String

        Public ReadOnly Property ZIPCode() As String Implements INewsZIPCode.ZIPCode
            Get
                Return _zipCode
            End Get
        End Property

        Friend Sub New(ByVal zipCode As String)
            _zipCode = zipCode
        End Sub
    End Class
End Namespace

