﻿<%@ Control Language="VB" ClassName="FeaturedBookPart" %>
<script runat="server">
 
    Private _bookTitle As String = "Untitled"
    Private _category As BookCategory = BookCategory.Computers
    Private _bookDescription As String
    Private _onSale As Boolean
 
    Public Enum BookCategory
        Computers
        History
        Mystery
    End Enum
 
    <Personalizable()> _
    <WebBrowsable()> _
    <WebDisplayName("Title")> _
    <WebDescription("The title of the book")> _
    Public Property BookTitle() As String
        Get
            Return _bookTitle
        End Get
        Set(ByVal Value As String)
            _bookTitle = value
        End Set
    End Property
 
    <Personalizable()> _
    <WebBrowsable()> _
    <WebDisplayName("Category")> _
    <WebDescription("The category of the book")> _
    Public Property Category() As BookCategory
        Get
            Return _category
        End Get
        Set(ByVal Value As BookCategory)
            _category = value
        End Set
    End Property
 
    <Personalizable()> _
    <WebBrowsable()> _
    <WebDisplayName("Description")> _
    <WebDescription("The description of the book")> _
    Public Property BookDescription() As String
        Get
            Return _bookDescription
        End Get
        Set(ByVal Value As String)
            _bookDescription = value
        End Set
    End Property
 
    <Personalizable()> _
    <WebBrowsable()> _
    <WebDisplayName("On Sale")> _
    <WebDescription("Indicates that the book is on sale")> _
    Public Property OnSale() As Boolean
        Get
            Return _onSale
        End Get
        Set(ByVal Value As Boolean)
            _onSale = value
        End Set
    End Property
 
    Private Sub Page_PreRender()
        ltlBookTitle.Text = _bookTitle
        lblCategory.Text = _category.ToString()
        lblBookDescription.Text = _bookDescription
        lblOnSale.Visible = _onSale
    End Sub

</script>
<h1 class="bookTitle">
<asp:Literal 
    ID="ltlBookTitle" 
    runat="server"/>
</h1>
<asp:Label 
    ID="lblCategory" 
    CssClass="category"
    runat="server" />
<br />
<asp:Label 
    ID="lblBookDescription" 
    runat="server" />
<br />
<asp:Label 
    ID="lblOnSale"
    Text="On Sale!" 
    Visible="false" 
    CssClass="onSale"
    runat="server" />
