﻿<%@ Control Language="VB" ClassName="FeaturedMoviePart" %>

<script runat="server">
     
    Public Enum MovieCategory
        Action
        Animation
        Drama
        Horror
    End Enum
 
    Private _movieTitle As String
    Private _category As MovieCategory
    Private _movieDescription As String
    Private _inTheaters As Boolean
 
    <Personalizable()> _
    <WebBrowsable()> _
    <WebDisplayName("Title")> _
    <WebDescription("The title of the movie")> _
    Public Property MovieTitle() As String
        Get
            Return _movieTitle
        End Get
        Set(ByVal Value As String)
            _movieTitle = value
        End Set
    End Property
 
    <Personalizable()> _
    <WebBrowsable()> _
    <WebDisplayName("Category")> _
    <WebDescription("The movie category")> _
    Public Property Category() As MovieCategory
        Get
            Return _category
        End Get
        Set(ByVal Value As MovieCategory)
            _category = value
        End Set
    End Property
 
    <Personalizable()> _
    <WebBrowsable()> _
    <WebDisplayName("Description")> _
    <WebDescription("The movie description")> _
    Public Property MovieDescription() As String
        Get
            Return _movieDescription
        End Get
        Set(ByVal Value As String)
            _movieDescription = value
        End Set
    End Property
 
    <Personalizable()> _
    <WebBrowsable()> _
    <WebDisplayName("In Theaters")> _
    <WebDescription("Is the movie currently showing?")> _
    Public Property InTheaters() As Boolean
        Get
            Return _inTheaters
        End Get
        Set(ByVal Value As Boolean)
            _inTheaters = value
        End Set
    End Property
 
    Private Sub Page_PreRender()
        lblMovieTitle.Text = _movieTitle
        lblCategory.Text = _category.ToString()
        lblMovieDescription.Text = _movieDescription
        lblInTheaters.Visible = _inTheaters
    End Sub
</script>
<asp:Label
    id="lblMovieTitle"
    Runat="server" />
<br />
<asp:Label
    id="lblCategory"
    Runat="server" />    
<br />
<asp:Label
    id="lblMovieDescription"
    Runat="server" />    
<br />
<asp:Label
    id="lblInTheaters"
    Text="In Theaters Now!"
    CssClass="inTheaters"
    Runat="server" />    
