﻿<%@ Control Language="VB" ClassName="WeatherPart" %>

<script runat="server">
 
    Private _zipCode As IZIPCode
 
    ''' <summary>
    ''' This method retrieves the IZIPCode interface returned
    ''' by the ProvideZIPCode method
    ''' </summary>
    <ConnectionConsumer("ZIP Code")> _ 
    Public  Sub ConsumeZIPCode(ByVal zipCode As IZIPCode)
        _zipCode = zipCode
    End Sub
 

    ''' <summary>
    ''' Display the weather
    ''' </summary>
    Private  Sub Page_PreRender()
        ' Check if we are connected
        If Not _zipCode Is Nothing Then
            If _zipCode.ZIPCode <> String.Empty Then
                lblWeather.Text = String.Format("The weather for {0} is expected to be sunny!", _zipCode.ZIPCode)
            Else 
                lblWeather.Text = "Please enter your ZIP code"
            End If
        End If
    End Sub

</script>

<h3>Current Weather</h3>
<asp:Label
    id="lblWeather"
    Runat="server" />