using System;
using System.Web.UI;
using System.Web.UI.WebControls.WebParts;

namespace myControls
{
    /// <summary>
    /// This Web Part illustrates how to
    /// use the HelpUrl and HelpMode properties
    /// </summary>
    public class ConfusingPart : WebPart
    {
        private string _title = "Confusing Part";
        private string _helpUrl = "~/ConfusingPartHelp.aspx";
        private WebPartHelpMode _helpMode = WebPartHelpMode.Modal;

        public override string Title
        {
            get { return _title; }
            set { _title = value; }
        }

        public override string HelpUrl
        {
            get { return _helpUrl; }
            set { _helpUrl = value; }
        }

        public override WebPartHelpMode HelpMode
        {
            get { return _helpMode; }
            set { _helpMode = value; }
        }

        protected override void RenderContents(HtmlTextWriter writer)
        {
            writer.RenderBeginTag(HtmlTextWriterTag.H1);
            writer.Write("This Web Part is confusing");
            writer.RenderEndTag();
            writer.Write("Select the Help menu option for help");
        }

    }
}