using System;
using System.Collections.Generic;
using System.Web.UI;
using System.Web.UI.WebControls.WebParts;

namespace myControls
{
    public class ProductPart : WebPart
    {
        private string _title = "Product Part";
        private string _productName;
        private decimal _productPrice;

        public override string Title
        {
            get { return _title; }
            set { _title = value; }
        }

        public override WebPartVerbCollection Verbs
        {
            get
            {
                List<WebPartVerb> menu = new List<WebPartVerb>();
                WebPartVerb menuItem = new WebPartVerb("AddToCart", AddToCart);
                menuItem.Text = "Add To Cart";
                menuItem.Description = "Adds item to shopping cart";
                menuItem.ImageUrl = "~/Images/AddToCart.gif";
                menu.Add(menuItem);
                return new WebPartVerbCollection(menu);
            }
        }

        public void AddToCart(Object s, WebPartEventArgs e)
        {
            WebPartManager wpm = WebPartManager.GetCurrentWebPartManager(Page);
            wpm.MoveWebPart(e.WebPart, wpm.Zones["ShoppingCartZone"], 0);
        }

        public string ProductName
        {
            get { return _productName; }
            set { _productName = value; }
        }

        public decimal ProductPrice
        {
            get { return _productPrice; }
            set { _productPrice = value; }
        }

        protected override void RenderContents(HtmlTextWriter writer)
        {
            writer.RenderBeginTag(HtmlTextWriterTag.H3);
            writer.Write(_productName);
            writer.RenderEndTag();
            writer.Write("Price: {0:c}", _productPrice);
        }

    }
}