<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<script runat="server">
    
    /// <summary>
    /// Minimize All Web Parts
    /// </summary>
    protected void lnkMinimizeAll_Click(object sender, EventArgs e)
    {
        foreach (WebPart part in WebPartManager1.WebParts)
            part.ChromeState = PartChromeState.Minimized;
    }
    
    /// <summary>
    /// Minimize Zone 1 Web Parts
    /// </summary>
    protected void lnkMinimizeZone1_Click(object sender, EventArgs e)
    {
        foreach (WebPart part in WebPartZone1.WebParts)
            part.ChromeState = PartChromeState.Minimized;
    }

    /// <summary>
    /// Minimize Zone 2 Web Parts
    /// </summary>
    protected void lnkMinimizeZone2_Click(object sender, EventArgs e)
    {
        foreach (WebPart part in WebPartZone2.WebParts)
            part.ChromeState = PartChromeState.Minimized;
    }

</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
    <style type="text/css">
        .column 
        {
            float:left;
            width:30%;
            height:200px;
            margin-right:10px;
            border:solid 1px black;
            background-color: white;
        }        
        html
        {
            background-color:#eeeeee;
        }
    </style>
    <title>Minimize Web Parts</title>
</head>
<body>
    <form id="form1" runat="server">
    <asp:WebPartManager
        id="WebPartManager1"
        Runat="server" />

    <asp:LinkButton
        id="lnkMinimizeAll"
        Text="Minimize All"
        Runat="server" OnClick="lnkMinimizeAll_Click" />

    <div class="column">
    <asp:LinkButton
        id="lnkMinimizeZone1"
        Text="Minimize"
        OnClick="lnkMinimizeZone1_Click"        
        Runat="server" />
    <asp:WebPartZone
        id="WebPartZone1"
        Runat="server">
        <ZoneTemplate>
        <asp:Label
            id="Label1"
            Title="First Part"
            Text="First Part"
            Runat="server" />
        <asp:Label
            id="Label2"
            Title="Second Part"
            Text="Second Part"
            Runat="server" />           
        </ZoneTemplate>
    </asp:WebPartZone>
    </div>
    
    <div class="column">
    <asp:LinkButton
        id="lnkMinimizeZone2"
        Text="Minimize"
        OnClick="lnkMinimizeZone2_Click" 
        Runat="server" />    
    <asp:WebPartZone
        id="WebPartZone2"
        Runat="server">    
        <ZoneTemplate>
        <asp:Label
            id="Label3"
            Title="Third Part"
            Text="Third Part"
            Runat="server" />
        <asp:Label
            id="Label4"
            Title="Fourth Part"
            Text="Fourth Part"
            Runat="server" />           
        </ZoneTemplate>
    </asp:WebPartZone>
    </div>
    
    </form>
</body>
</html>
