Imports System
Imports System.Collections.Generic
Imports System.Web.UI
Imports System.Web.UI.WebControls.WebParts

Namespace myControls
    Public Class ProductPart
        Inherits WebPart
        Private _title As String = "Product Part"
        Private _productName As String
        Private _productPrice As Decimal

        Public Overrides Property Title() As String
            Get
                Return _title
            End Get
            Set(ByVal Value As String)
                _title = value
            End Set
        End Property

        Public Overrides ReadOnly Property Verbs() As WebPartVerbCollection
            Get
                Dim menu As New List(Of WebPartVerb)()
                Dim menuItem As New WebPartVerb("AddToCart", AddressOf AddToCart)
                menuItem.Text = "Add To Cart"
                menuItem.Description = "Adds item to shopping cart"
                menuItem.ImageUrl = "~/Images/AddToCart.gif"
                menu.Add(menuItem)
                Return New WebPartVerbCollection(menu)
            End Get
        End Property

        Public Sub AddToCart(ByVal s As Object, ByVal e As WebPartEventArgs)
            Dim wpm As WebPartManager = WebPartManager.GetCurrentWebPartManager(Page)
            wpm.MoveWebPart(e.WebPart, wpm.Zones("ShoppingCartZone"), 0)
        End Sub

        Public Property ProductName() As String
            Get
                Return _productName
            End Get
            Set(ByVal Value As String)
                _productName = value
            End Set
        End Property

        Public Property ProductPrice() As Decimal
            Get
                Return _productPrice
            End Get
            Set(ByVal Value As Decimal)
                _productPrice = value
            End Set
        End Property

        Protected Overrides Sub RenderContents(ByVal writer As HtmlTextWriter)
            writer.RenderBeginTag(HtmlTextWriterTag.H3)
            writer.Write(_productName)
            writer.RenderEndTag()
            writer.Write("Price: {0:c}", _productPrice)
        End Sub

    End Class
End Namespace
