<%@ Page Language="VB" %>
<%@ Register TagPrefix="user" TagName="MissionStatementPart" Src="~/MissionStatementPart.ascx" %>
<%@ Register TagPrefix="user" TagName="WorldDominationPlansPart" Src="~/WorldDominationPlansPart.ascx" %>
<%@ Register TagPrefix="user" TagName="CopyingMachineLocationsPart" Src="~/CopyingMachinesLocationPart.ascx" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<script runat="server">
 
    ''' <summary>
    ''' Create the Administrator and Serf roles and
    ''' create two users named Bill and Tom.
    ''' </summary>
    Private  Sub Page_Load()
        If Not Roles.RoleExists("Administrator") Then
            Roles.CreateRole("Administrator")
            Roles.CreateRole("Serf")
            Membership.CreateUser("Bill", "secret")
            Membership.CreateUser("Tom", "secret")
            Roles.AddUserToRoles("Bill", New String(){"Administrator", "Serf"})
            Roles.AddUserToRole("Tom", "Serf")
        End If
    End Sub
 
    ''' <summary>
    ''' Only add a Web Part when the AuthorizationFilter
    ''' property contains the current user's role or the
    ''' AuthorizationFilter property is empty.
    ''' </summary>
    Protected  Sub WebPartManager1_AuthorizeWebPart(ByVal sender As Object, ByVal e As WebPartAuthorizationEventArgs)
        e.IsAuthorized = User.IsInRole(e.AuthorizationFilter) Or e.AuthorizationFilter = String.Empty
    End Sub
 
    ''' <summary>
    ''' Hide the menu for unauthorized users
    ''' </summary>
    Private  Sub Page_PreRender()
        Menu1.Visible = Request.IsAuthenticated
    End Sub
 
    Protected  Sub Menu1_MenuItemClick(ByVal sender As Object, ByVal e As MenuEventArgs)
        WebPartManager1.DisplayMode = WebPartManager1.DisplayModes(e.Item.Text)
    End Sub

</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
    <style type="text/css">
        .login
        {
            border:solid 1px black;
            background-color:white;
        }
        .column 
        {
            float:left;
            width:30%;
            height:200px;
            margin-right:10px;
            border:solid 1px black;
            background-color: white;
        }        
        .menu
        {
            margin:5px 0px;
        }
        html
        {
            background-color:#eeeeee;
        }
    </style>
    <title>Show Authorization Filter</title>
</head>
<body>
    <form id="form1" runat="server">
    <asp:WebPartManager
        id="WebPartManager1"
        OnAuthorizeWebPart="WebPartManager1_AuthorizeWebPart"
        Runat="server" />

    <asp:Login
        id="Login1"
        CssClass="login"
        TitleText=""
        Orientation="horizontal"
        DisplayRememberMe="false"
        Runat="server" />

    <asp:Menu
        id="Menu1"
        OnMenuItemClick="Menu1_MenuItemClick"
        Orientation="Horizontal"
        CssClass="menu"
        Runat="server">
        <Items>
        <asp:MenuItem Text="Browse" />
        <asp:MenuItem Text="Design" />
        <asp:MenuItem Text="Catalog" />
        </Items>
    </asp:Menu>    

    <asp:WebPartZone
        id="WebPartZone1"
        CssClass="column"
        Runat="server">
        <ZoneTemplate>
        <user:MissionStatementPart
            id="MissionStatementPart1"
            title="Mission Statement"
            runat="server" />            
        <user:CopyingMachineLocationsPart
            id="CopyingMachineLocationsPart1"
            title="Copying Machine Locations"
            AuthorizationFilter="Serf"
            runat="server" />    
        <user:WorldDominationPlansPart
            id="WorldDominationPart1"
            title="World Domination Plans"
            AuthorizationFilter="Administrator"
            runat="server" />    
        </ZoneTemplate>
    </asp:WebPartZone>

    <asp:WebPartZone
        id="WebPartZone2"
        CssClass="column"
        Runat="server" />    

    <asp:CatalogZone
        id="CatalogZone1"
        CssClass="column"
        Runat="server">
        <ZoneTemplate>
        <asp:DeclarativeCatalogPart
            id="DeclarativeCatalogPart"
            Runat="server">
            <WebPartsTemplate>
            <user:CopyingMachineLocationsPart
                id="CopyingMachineLocationsPart1"
                title="Copying Machine Locations"
                AuthorizationFilter="Serf"
                runat="server" />    
            <user:WorldDominationPlansPart
                id="WorldDominationPart1"
                title="World Domination Plans"
                AuthorizationFilter="Administrator"
                runat="server" />    
            </WebPartsTemplate>
        </asp:DeclarativeCatalogPart>    
        <asp:PageCatalogPart 
            id="PageCatalogPart1"
            Runat="server" />
        </ZoneTemplate>
    </asp:CatalogZone>
    
    </form>
</body>
</html>
