<%@ Page Language="VB" %>
<%@ Import Namespace="System.Collections.Generic" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<script runat="server">
 
    ''' <summary>
    ''' Create the verbs which will appear for every
    ''' Web Part in the Product Zone
    ''' </summary>
    Protected  Sub ProductZone_CreateVerbs(ByVal sender As Object, ByVal e As WebPartVerbsEventArgs)
        Dim menu As New List(Of WebPartVerb)() 
        Dim menuItem As New WebPartVerb("AddToCart", AddressOf AddToCart, "return confirm('Are You Sure?');")
        menuItem.Text = "Add To Cart"
        menuItem.Description = "Adds item to shopping cart"
        menuItem.ImageUrl = "~/Images/AddToCart.gif"
        menu.Add(menuItem)
        e.Verbs = New WebPartVerbCollection(e.Verbs, menu)
    End Sub
 
    ''' <summary>
    ''' Move a Web Part from the Product Zone
    ''' to the Shopping Cart Zone
    ''' </summary>
    Public  Sub AddToCart(ByVal s As Object, ByVal e As WebPartEventArgs)
        Dim wpm As WebPartManager =  WebPartManager.GetCurrentWebPartManager(Page) 
        wpm.MoveWebPart(e.WebPart, wpm.Zones("ShoppingCartZone"), 0)
    End Sub
 
    Protected  Sub lnkClear_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim part As WebPart
        For Each part In ShoppingCartZone.WebParts
            WebPartManager1.MoveWebPart(part, ProductZone, 0)
        Next
    End Sub
 
    Private  Sub Page_PreRender()
        lnkClear.Visible = (ShoppingCartZone.WebParts.Count > 0)
    End Sub

</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
    <style type="text/css">
        .column 
        {
            float:left;
            width:40%;
            padding:10px;
            height:200px;
            margin-right:10px;
            border:solid 1px black;
            background-color: white;
        }       
        html
        {
            background-color:#eeeeee;
        }
    </style>
    <title>Show Zone Verbs</title>
</head>
<body>
    <form id="form1" runat="server">
    <asp:WebPartManager
        id="WebPartManager1"
        Runat="server" />
        
        <div class="column">
        <h1>Products</h1>
        <asp:WebPartZone
            id="ProductZone"
            OnCreateVerbs="ProductZone_CreateVerbs"
            HeaderText="Products"
            MenuPopupStyle-BackColor="aliceBlue"
            MenuPopupStyle-BorderStyle="solid"
            MenuPopupStyle-BorderWidth="1px"
            MenuPopupStyle-BorderColor="black"
            MenuPopupStyle-ShadowColor="lightgray"
            AllowLayoutChange="false"
            Runat="server">
            <ZoneTemplate>
            <asp:Label
                id="Label1"
                Title="Product"
                Text="Laptop Computer -- $900.00"
                Runat="server" />
            <asp:Label
                id="Label2"
                Title="Product"
                Text="Computer Monitor -- $900.00"
                Runat="server" />            
            <asp:Label
                id="Label3"
                Title="Product"
                Text="Network Card -- $64.20"
                Runat="server" />                
            </ZoneTemplate>
        </asp:WebPartZone>        
        </div>
        
        <div class="column">
        <h1>Shopping Cart</h1>
        <asp:WebPartZone
            id="ShoppingCartZone"
            HeaderText="Shopping Cart"
            VerbStyle-CssClass="verbs"
            AllowLayoutChange="false"
            Runat="server"/>
        <asp:LinkButton
            id="lnkClear"
            Text="Clear Cart"
            OnClick="lnkClear_Click"
            runat="server" />        
        </div>
    </form>
</body>
</html>
