using System;
using System.Collections;
using System.Web;
using System.Web.UI.WebControls.WebParts;

namespace myControls
{

    /// <summary>
    /// Overrides the standard WebPartPersonalization class
    /// to enable anonymous users to modify state.
    /// </summary>
    public class AnonWebPartPersonalization : WebPartPersonalization
    {

        public AnonWebPartPersonalization(WebPartManager webPartManager)
            : base(webPartManager){}

        protected override IDictionary UserCapabilities
        {
            get
            {
                if (HttpContext.Current.Request.IsAuthenticated == true)
                    return base.UserCapabilities;
                else
                {
                    Hashtable capabilities = new Hashtable();
                    capabilities.Add(WebPartPersonalization.ModifyStateUserCapability, WebPartPersonalization.ModifyStateUserCapability);
                    return capabilities;
                }
            }
        }
    }
}
