﻿<%@ Control Language="C#" ClassName="PersonalizationManager" %>
<script runat="server">
    
    /// <summary>
    /// Display Personalization Information
    /// </summary>
    void Page_PreRender()
    {
        WebPartManager wpm = WebPartManager.GetCurrentWebPartManager(Page);
        lblCurrentScope.Text = wpm.Personalization.Scope.ToString();
        lblIsModifiable.Text = wpm.Personalization.IsModifiable.ToString();
        lblCanEnterSharedScope.Text = wpm.Personalization.CanEnterSharedScope.ToString();
        lblHasPersonalizationState.Text = wpm.Personalization.HasPersonalizationState.ToString();
        lnkToggleScope.Visible = wpm.Personalization.CanEnterSharedScope;
    }
    
    /// <summary>
    /// Switches to Shared Scope
    /// </summary>
    protected void lnkToggleScope_Click(object sender, EventArgs e)
    {
        WebPartManager wpm = WebPartManager.GetCurrentWebPartManager(Page);
        wpm.Personalization.ToggleScope();
    }

    /// <summary>
    /// Deletes Personalization data
    /// </summary>
    protected void lnkReset_Click(object sender, EventArgs e)
    {
        WebPartManager wpm = WebPartManager.GetCurrentWebPartManager(Page);
        wpm.Personalization.ResetPersonalizationState();
    }
</script>

<div class="personalizationManager">
Current Scope:
<asp:Label
    id="lblCurrentScope"
    Runat="server" />
Can Modify State:
<asp:Label
    id="lblIsModifiable"
    Runat="server" />
Can Enter Shared Scope:
<asp:Label
    id="lblCanEnterSharedScope"
    Runat="server" />
Has Personalization State:
<asp:Label
    id="lblHasPersonalizationState"
    Runat="server" />
<span>
<asp:LinkButton
    id="lnkToggleScope"
    Text="Toggle Scope"
    OnClick="lnkToggleScope_Click" 
    Runat="server" />
</span>
<asp:LinkButton
    id="lnkReset"
    Text="Reset Personalization"
    Runat="server" OnClick="lnkReset_Click" />
</div>