Imports System
Imports System.Collections
Imports System.Web
Imports System.Web.UI.WebControls.WebParts

Namespace myControls

    ''' <summary>
    ''' Overrides the standard WebPartPersonalization class
    ''' to enable anonymous users to modify state.
    ''' </summary>
    Public Class AnonWebPartPersonalization
        Inherits WebPartPersonalization

        Public Sub New(ByVal webPartManager As WebPartManager)
            MyBase.New(webPartManager)
        End Sub

        Protected Overrides ReadOnly Property UserCapabilities() As IDictionary
            Get
                If HttpContext.Current.Request.IsAuthenticated = True Then
                    Return MyBase.UserCapabilities
                Else
                    Dim capabilities As Hashtable = New Hashtable()
                    capabilities.Add(WebPartPersonalization.ModifyStateUserCapability, WebPartPersonalization.ModifyStateUserCapability)
                    Return capabilities
                End If
            End Get
        End Property
    End Class
End Namespace

