Imports System
Imports System.Web
Imports System.Web.UI.WebControls.WebParts

Namespace myControls

    ''' <summary>
    ''' Custom personalization provider which takes into account the
    ''' id query string parameter.
    ''' </summary>
    Public Class QueryStringPersonalizationProvider
        Inherits SqlPersonalizationProvider

        ''' <summary>
        ''' Called when data is saved to the database
        ''' </summary>
        Protected Overrides Sub SavePersonalizationBlob(ByVal webPartManager As WebPartManager, ByVal path As String, ByVal userName As String, ByVal dataBlob() As Byte)
            Dim queryStringId As String = HttpContext.Current.Request("id")
            If Not queryStringId Is Nothing Then
                path += "?id=" + queryStringId
            End If
            MyBase.SavePersonalizationBlob(webPartManager, path, userName, dataBlob)
        End Sub

        ''' <summary>
        ''' Called when data is loaded from the database
        ''' </summary>
        Protected Overrides Sub LoadPersonalizationBlobs(ByVal webPartManager As WebPartManager, ByVal path As String, ByVal userName As String, ByRef sharedDataBlob() As Byte, ByRef userDataBlob() As Byte)
            Dim queryStringId As String = HttpContext.Current.Request("id")
            If Not queryStringId Is Nothing Then
                path += "?id=" + queryStringId
            End If
            MyBase.LoadPersonalizationBlobs(webPartManager, path, userName, sharedDataBlob, userDataBlob)
        End Sub

        ''' <summary>
        ''' Called when a user's personalization data is reset
        ''' </summary>
        Protected Overrides Sub ResetPersonalizationBlob(ByVal webPartManager As WebPartManager, ByVal path As String, ByVal userName As String)
            Dim queryStringId As String = HttpContext.Current.Request("id")
            If Not queryStringId Is Nothing Then
                path += "?id=" + queryStringId
            End If
            MyBase.ResetPersonalizationBlob(webPartManager, path, userName)
        End Sub

    End Class
End Namespace
