﻿<%@ Control Language="VB" ClassName="PersonalizationManager" %>
<script runat="server">
 
    ''' <summary>
    ''' Display Personalization Information
    ''' </summary>
    Private Sub Page_PreRender()
        Dim wpm As WebPartManager = WebPartManager.GetCurrentWebPartManager(Page)
        lblCurrentScope.Text = wpm.Personalization.Scope.ToString()
        lblIsModifiable.Text = wpm.Personalization.IsModifiable.ToString()
        lblCanEnterSharedScope.Text = wpm.Personalization.CanEnterSharedScope.ToString()
        lblHasPersonalizationState.Text = wpm.Personalization.HasPersonalizationState.ToString()
        lnkToggleScope.Visible = wpm.Personalization.CanEnterSharedScope
    End Sub
 
    ''' <summary>
    ''' Switches to Shared Scope
    ''' </summary>
    Protected Sub lnkToggleScope_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim wpm As WebPartManager = WebPartManager.GetCurrentWebPartManager(Page)
        wpm.Personalization.ToggleScope()
    End Sub
 
    ''' <summary>
    ''' Deletes Personalization data
    ''' </summary>
    Protected Sub lnkReset_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim wpm As WebPartManager = WebPartManager.GetCurrentWebPartManager(Page)
        wpm.Personalization.ResetPersonalizationState()
    End Sub
</script>
<div class="personalizationManager">
Current Scope:
<asp:Label
    id="lblCurrentScope"
    Runat="server" />
Can Modify State:
<asp:Label
    id="lblIsModifiable"
    Runat="server" />
Can Enter Shared Scope:
<asp:Label
    id="lblCanEnterSharedScope"
    Runat="server" />
Has Personalization State:
<asp:Label
    id="lblHasPersonalizationState"
    Runat="server" />
<span>
<asp:LinkButton
    id="lnkToggleScope"
    Text="Toggle Scope"
    OnClick="lnkToggleScope_Click" 
    Runat="server" />
</span>
<asp:LinkButton
    id="lnkReset"
    Text="Reset Personalization"
    Runat="server" OnClick="lnkReset_Click" />
</div>