using System;
using System.Web.UI.WebControls.WebParts;

namespace myControls
{
    /// <summary>
    /// Extends WebPartManager control with support for
    /// HelpDisplayMode
    /// </summary>
    public class CustomWebPartManager : WebPartManager
    {
        public static readonly HelpDisplayMode HelpDisplayMode = new HelpDisplayMode("Help");

        protected override WebPartDisplayModeCollection CreateDisplayModes()
        {
            WebPartDisplayModeCollection modes = base.CreateDisplayModes();
            modes.Add(HelpDisplayMode);
            return modes;
        }

    }
}
