using System;
using System.Web.UI.WebControls.WebParts;

/// <summary>
/// Defines custom Help Display Mode
/// </summary>
public class HelpDisplayMode : WebPartDisplayMode
{

    public HelpDisplayMode(string name) : base(name) { }

    /// <summary>
    /// When true, users can move Web Parts
    /// </summary>
    public override bool AllowPageDesign
    {
        get { return false; }
    }

    /// <summary>
    /// When true, a HelpZone must be added
    /// to the page.
    /// </summary>
    public override bool AssociatedWithToolZone
    {
        get { return false; }
    }

    /// <summary>
    /// When true, an error is raised when
    /// personalization is disabled.
    /// </summary>
    public override bool RequiresPersonalization
    {
        get { return false; }
    }

    /// <summary>
    /// When true, hidden Web Parts
    /// are displayed.
    /// </summary>
    public override bool ShowHiddenWebParts
    {
        get { return true; }
    }

}
