using System;
using System.Web.UI;
using System.Web.UI.WebControls.WebParts;

namespace myControls
{

    /// <summary>
    /// Displays extended page help when a page
    /// is in Help Display Mode
    /// </summary>
    public class HelpZone : ToolZone
    {
        private string _contents = "Help Contents";
        private string _headerText = "Help";

        public HelpZone()
            : base(CustomWebPartManager.HelpDisplayMode) { }

        /// <summary>
        /// Text displayed in title bar
        /// </summary>
        public override string HeaderText
        {
            get { return _headerText; }
            set { _headerText = value; }
        }

        /// <summary>
        /// Represents the help text displayed in the
        /// Help Zone
        /// </summary>
        [PersistenceMode(PersistenceMode.InnerProperty)]
        public string Contents
        {
            get { return _contents; }
            set { _contents = value; }
        }

        /// <summary>
        /// Renders the help text
        /// </summary>
        protected override void RenderBody(HtmlTextWriter writer)
        {
            writer.Write(_contents);
        }

        /// <summary>
        /// When the user clicks Close, switch
        /// back to Browse Display Mode
        /// </summary>
        protected override void Close()
        {
            this.WebPartManager.DisplayMode = WebPartManager.BrowseDisplayMode;
        }
    }
}
