using System;
using System.Web.UI.WebControls.WebParts;

/// <summary>
/// Extends the base WebPartVerb class
/// with support for nested menus and menu
/// dividers.
/// </summary>
public class MenuWebPartVerb : WebPartVerb
{
    private string _parentVerbId = String.Empty;
    private bool _hasDivider = false;

    /// <summary>
    /// Enables you to nest one menu beneath another
    /// </summary>
    public string parentVerbId
    {
        get { return _parentVerbId; }
        set { _parentVerbId = value; }
    }

    /// <summary>
    /// This property enables you to render a divider
    /// above the menu item.
    /// </summary>
    public bool hasDivider
    {
        get { return _hasDivider; }
        set { _hasDivider = value; }
    }

    /// <summary>
    /// We need to include the base class constructors
    /// in our derived class
    /// </summary>
    public MenuWebPartVerb(string id, string clientClickHandler)
        : base(id, clientClickHandler) { }

    public MenuWebPartVerb(string id, WebPartEventHandler serverClickHandler)
        : base(id, serverClickHandler) { }

    public MenuWebPartVerb(string id, WebPartEventHandler serverClickHandler, string clientClickHandler)
        : base(id, serverClickHandler, clientClickHandler) { }
}
