using System;
using System.Web.UI.WebControls.WebParts;

namespace myControls
{

    /// <summary>
    /// Web Part Zone which displays fancy nested menus
    /// </summary>
    public class MenuWebPartZone : WebPartZone
    {
        /// <summary>
        /// Register the client-script for the menus.
        /// </summary>
        protected override void OnPreRender(EventArgs e)
        {
            if (!Page.ClientScript.IsClientScriptIncludeRegistered("MenuWebPartZone"))
                Page.ClientScript.RegisterClientScriptInclude("MenuWebPartZone", Page.ResolveUrl("~/ClientScripts/MenuWebPartZone.js"));
            base.OnPreRender(e);
        }

        /// <summary>
        /// Create special Web Part Chrome that contains the menus
        /// </summary>
        protected override WebPartChrome CreateWebPartChrome()
        {
            return new MenuWebPartChrome(this, this.WebPartManager);
        }


    }
}