
var dragDropCatalogZone = new function()
    {
        this.start = dragDropCatalogZone_start;
        this.addWebPart = dragDropCatalogZone_addWebPart;
    }


function dragDropCatalogZone_start(catalogZoneId)
    {
        // Get Catalog Zone
        var catalogZone = document.getElementById(catalogZoneId);
        
        // Find Element with Draggable Class
        var draggable = document.getElementById(catalogZoneId + '_draggable');
 
        // Get Images contained in Draggable
        var images = draggable.getElementsByTagName('img');

        // Get Inputs contained in Draggable
        var inputs = draggable.getElementsByTagName('input');
        
        // Check that Images == Inputs
        if (images.length != inputs.length)
        {
            alert('DragDropCatalogZone:Each catalog item must have a catalog icon');
            return;
        }

        // Convert images into Web Parts
        for (var i=0;i<images.length;i++)
        {
            var catItem = new WebPart(images[i],images[i]);
            images[i].webPartId = inputs[i].value;
            images[i].detachEvent("ondragend", WebPart_OnDragEnd);
            images[i].attachEvent("ondragend", dragDropCatalogZone.addWebPart);
        }
        
        // Add Drop Handler to WebPartManager
        __wpm.xCatalogZoneId = catalogZoneId; 
        __wpm.xCompleteAddWebPartDragDrop = dragDropCatalogZone_CompleteAddWebPartDragDrop;
    }
    
    
function dragDropCatalogZone_addWebPart()
    {
        __wpm.xCompleteAddWebPartDragDrop();
    }

function dragDropCatalogZone_CompleteAddWebPartDragDrop() {
    var dragState = this.dragState;
    this.dragState = null;
    if (dragState.dropZoneElement != null) {
        dragState.dropZoneElement.__zone.ToggleDropCues(false, dragState.dropIndex, false);
    }
    document.body.detachEvent("ondragover", Zone_OnDragOver);
    for (var i = 0; i < __wpm.zones.length; i++) {
        __wpm.zones[i].allowDrop = false;
    }
    this.overlayContainerElement.removeChild(this.overlayContainerElement.firstChild);
    this.overlayContainerElement.style.display = "none";
    if ((dragState != null) && (dragState.dropped == true)) {
        var currentZone = dragState.webPartElement.__webPart.zone;
        var currentZoneIndex = dragState.webPartElement.__webPart.zoneIndex;
        if ((currentZone != dragState.dropZoneElement.__zone) ||
            ((currentZoneIndex != dragState.dropIndex) &&
             (currentZoneIndex != (dragState.dropIndex - 1)))) {
            
            var eventTarget = this.xCatalogZoneId;
            var eventArgument = 'Add:' + dragState.webPartElement.webPartId + ':' + dragState.dropZoneElement.__zone.uniqueID + ':' + dragState.dropIndex;
            this.SubmitPage(eventTarget, eventArgument);
        }
    }
}
