﻿<%@ Control Language="C#" ClassName="FeaturedVideoEditTemplate" %>
<%@ Reference Control="~/FeaturedVideoPart.ascx" %>
<%@ Implements Interface="myControls.ITemplatedEditorPart" %>

<script runat="server">

    public void SyncChanges(Control controlToEdit)
    {
        ASP.FeaturedVideoPart part = (ASP.FeaturedVideoPart)controlToEdit;
        txtVideoTitle.Text = part.VideoTitle;
        txtDirector.Text = part.Director;
        txtPrice.Text = part.Price.ToString();
    }

    public bool ApplyChanges(Control controlToEdit)
    {
        bool success = false;
        Page.Validate();
        if (Page.IsValid)
        {
            ASP.FeaturedVideoPart part = (ASP.FeaturedVideoPart)controlToEdit;
            part.VideoTitle = txtVideoTitle.Text;
            part.Director = txtDirector.Text;
            part.Price = decimal.Parse(txtPrice.Text);            
            success = true;
        }
        return success;
    }
</script>

<asp:Label
    id="lblVideoTitle"
    Text="Video Title:"
    AssociatedControlID="txtVideoTitle"
    Runat="server" />
<br />
<asp:TextBox
    id="txtVideoTitle"
    Runat="server" />

<br /><br />

<asp:Label
    id="lblDirector"
    Text="Director:"
    AssociatedControlID="txtDirector"
    Runat="server" />
<br />
<asp:TextBox
    id="txtDirector"
    Runat="server" />

<br /><br />

<asp:Label
    id="lblPrice"
    Text="Price:"
    AssociatedControlID="txtPrice"
    Runat="server" />
<br />
<asp:TextBox
    id="txtPrice"
    Runat="server" />
<asp:CompareValidator
    id="valprice"
    ControlToValidate="txtPrice"
    Display="dynamic"
    Text="(Must be Currency)"
    Type="Currency"
    Operator="DataTypeCheck"
    Runat="server" />    
<asp:RequiredFieldValidator
    ControlToValidate="txtPrice"
    Display="dynamic"
    Text="(Required)"
    Runat="server" />    
