﻿<%@ Control Language="C#" ClassName="TextEditorPart" %>
<%@ Implements Interface="System.Web.UI.WebControls.WebParts.IWebActionable" %>
<%@ Import Namespace="System.Collections.Generic" %>

<script runat="server">

    /// <summary>
    /// Create the menu
    /// </summary>
    public WebPartVerbCollection Verbs
    {
        get
        {
            List<WebPartVerb> myVerbs = new List<WebPartVerb>();
            
            // Create File menu
            MenuWebPartVerb fileVerb = new MenuWebPartVerb("file", doMenuAction);
            fileVerb.Text = "File";
            myVerbs.Add(fileVerb);

            MenuWebPartVerb newVerb = new MenuWebPartVerb("new", doMenuAction);
            newVerb.Text = "New";
            newVerb.parentVerbId = fileVerb.ID;
            myVerbs.Add(newVerb);

            // Create Edit menu
            MenuWebPartVerb editVerb = new MenuWebPartVerb("edit", doMenuAction);
            editVerb.Text = "Edit";
            myVerbs.Add(editVerb);

            MenuWebPartVerb copyVerb = new MenuWebPartVerb("copy", doMenuAction);
            copyVerb.Text = "Copy";
            copyVerb.parentVerbId = editVerb.ID;
            myVerbs.Add(copyVerb);

            MenuWebPartVerb pasteVerb = new MenuWebPartVerb("pasted", doMenuAction);
            pasteVerb.Text = "Paste";
            pasteVerb.parentVerbId = editVerb.ID;
            myVerbs.Add(pasteVerb);

            MenuWebPartVerb boldVerb = new MenuWebPartVerb("bold", doMenuAction);
            boldVerb.Text = "Bold";
            boldVerb.ImageUrl = "~/Icons/Bold.gif";
            boldVerb.hasDivider = true;
            boldVerb.parentVerbId = editVerb.ID;
            myVerbs.Add(boldVerb);

            MenuWebPartVerb italicVerb = new MenuWebPartVerb("italic", doMenuAction);
            italicVerb.Text = "Italic";
            italicVerb.ImageUrl = "~/Icons/Italic.gif";
            italicVerb.parentVerbId = editVerb.ID;
            myVerbs.Add(italicVerb);
            
            
            // Return the menu
            return new WebPartVerbCollection(myVerbs);
        }
    }

    /// <summary>
    /// The server-side method which is invoked when you
    /// click a menu item
    /// </summary>
    public void doMenuAction(Object s, WebPartEventArgs e)
    {
        MenuWebPartVerb verb = (MenuWebPartVerb)s;
        lblAction.Text = String.Format("{0} clicked!", verb.Text);
    }
    
    
</script>

<div style="padding:10px">

Select a menu item from the menu above the title bar.
<br />
<asp:Label
    id="lblAction"
    EnableViewState="false"
    Runat="server" /> 
</div>