Imports System
Imports System.Web.UI.WebControls.WebParts

''' <summary>
''' Defines custom Help Display Mode
''' </summary>
Public Class HelpDisplayMode
    Inherits WebPartDisplayMode

    Public Sub New(ByVal name As String)
        MyBase.New(name)
    End Sub

    ''' <summary>
    ''' When true, users can move Web Parts
    ''' </summary>
    Public Overrides ReadOnly Property AllowPageDesign() As Boolean
        Get
            Return False
        End Get
    End Property

    ''' <summary>
    ''' When true, a HelpZone must be added
    ''' to the page.
    ''' </summary>
    Public Overrides ReadOnly Property AssociatedWithToolZone() As Boolean
        Get
            Return False
        End Get
    End Property

    ''' <summary>
    ''' When true, an error is raised when
    ''' personalization is disabled.
    ''' </summary>
    Public Overrides ReadOnly Property RequiresPersonalization() As Boolean
        Get
            Return False
        End Get
    End Property

    ''' <summary>
    ''' When true, hidden Web Parts
    ''' are displayed.
    ''' </summary>
    Public Overrides ReadOnly Property ShowHiddenWebParts() As Boolean
        Get
            Return True
        End Get
    End Property

End Class

