Imports System
Imports System.Web.UI
Imports System.Web.UI.WebControls.WebParts

Namespace myControls

    ''' <summary>
    ''' Displays extended page help when a page
    ''' is in Help Display Mode
    ''' </summary>
    Public Class HelpZone
        Inherits ToolZone
        Private _contents As String = "Help Contents"
        Private _headerText As String = "Help"

        Public Sub New()
            MyBase.New(CustomWebPartManager.HelpDisplayMode)
        End Sub

        ''' <summary>
        ''' Text displayed in title bar
        ''' </summary>
        Public Overrides Property HeaderText() As String
            Get
                Return _headerText
            End Get
            Set(ByVal Value As String)
                _headerText = Value
            End Set
        End Property

        ''' <summary>
        ''' Represents the help text displayed in the
        ''' Help Zone
        ''' </summary>
        <PersistenceMode(PersistenceMode.InnerProperty)> _
        Public Property Contents() As String
            Get
                Return _contents
            End Get
            Set(ByVal Value As String)
                _contents = Value
            End Set
        End Property

        ''' <summary>
        ''' Renders the help text
        ''' </summary>
        Protected Overrides Sub RenderBody(ByVal writer As HtmlTextWriter)
            writer.Write(_contents)
        End Sub

        ''' <summary>
        ''' When the user clicks Close, switch
        ''' back to Browse Display Mode
        ''' </summary>
        Protected Overrides Sub Close()
            Me.WebPartManager.DisplayMode = WebPartManager.BrowseDisplayMode
        End Sub
    End Class
End Namespace

