Imports System
Imports System.Web.UI.WebControls.WebParts

''' <summary>
''' Extends the base WebPartVerb class
''' with support for nested menus and menu
''' dividers.
''' </summary>
Public Class MenuWebPartVerb
    Inherits WebPartVerb

    Private _parentVerbId As String = String.Empty
    Private _hasDivider As Boolean = False

    ''' <summary>
    ''' Enables you to nest one menu beneath another
    ''' </summary>
    Public Property parentVerbId() As String
        Get
            Return _parentVerbId
        End Get
        Set(ByVal Value As String)
            _parentVerbId = Value
        End Set
    End Property

    ''' <summary>
    ''' This property enables you to render a divider
    ''' above the menu item.
    ''' </summary>
    Public Property hasDivider() As Boolean
        Get
            Return _hasDivider
        End Get
        Set(ByVal Value As Boolean)
            _hasDivider = Value
        End Set
    End Property

    ''' <summary>
    ''' We need to include the base class constructors
    ''' in our derived class
    ''' </summary>
    Public Sub New(ByVal id As String, ByVal clientClickHandler As String)
        MyBase.New(id, clientClickHandler)
    End Sub

    Public Sub New(ByVal id As String, ByVal serverClickHandler As WebPartEventHandler)
        MyBase.New(id, serverClickHandler)
    End Sub

    Public Sub New(ByVal id As String, ByVal serverClickHandler As WebPartEventHandler, ByVal clientClickHandler As String)
        MyBase.New(id, serverClickHandler, clientClickHandler)
    End Sub
End Class

