Imports System
Imports System.IO
Imports System.Collections.Generic
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts

Namespace myControls

    Public Class PhotoWebPartZone
        Inherits WebPartZoneBase
        Dim _photoFolderUrl As String = "~/Photos"

        ''' <summary>
        ''' Represents the URL for the folder which
        ''' contains the photos.
        ''' </summary>
        Public Property PhotoFolderUrl() As String
            Get
                Return _photoFolderUrl
            End Get
            Set(ByVal Value As String)
                _photoFolderUrl = Value
            End Set
        End Property

        ''' <summary>
        ''' Get the initial Web Parts from the Photo Folder
        ''' </summary>
        Protected Overrides Function GetInitialWebParts() As WebPartCollection
            ' Don't do anything when displayed in Designer
            If (Me.DesignMode) Then
                Return New WebPartCollection()
            End If

            ' Get the WebPartManager control
            Dim wpm As WebPartManager = WebPartManager.GetCurrentWebPartManager(Page)

            ' Create a WebPart collection
            Dim photos As New List(Of WebPart)()

            ' Get the list of photos
            Dim photoDir As DirectoryInfo = New DirectoryInfo(Page.MapPath(_photoFolderUrl))
            Dim files() As FileInfo = photoDir.GetFiles()
            Dim file As FileInfo
            For Each file In files
                Dim photo As Image = New Image()
                photo.ID = Path.GetFileNameWithoutExtension(file.Name)
                photo.ImageUrl = Path.Combine(_photoFolderUrl, file.Name)
                photo.Width = Unit.Pixel(200)
                photo.Attributes.Add("Title", file.Name)
                photo.AlternateText = file.Name + " Photo"
                photos.Add(wpm.CreateWebPart(photo))
            Next

            ' Return WebPartCollection
            Return New WebPartCollection(photos)
        End Function

    End Class
End Namespace

