﻿<%@ Control Language="VB" ClassName="FeaturedVideoEditTemplate" %>
<%@ Reference Control="~/FeaturedVideoPart.ascx" %>
<%@ Implements Interface="myControls.ITemplatedEditorPart" %>
<%@ Import Namespace="myControls" %>

<script runat="server">
 
    Public Sub SyncChanges(ByVal controlToEdit As Control) Implements ITemplatedEditorPart.SyncChanges
        Dim part As ASP.FeaturedVideoPart = CType(controlToEdit, ASP.FeaturedVideoPart)
        txtVideoTitle.Text = part.VideoTitle
        txtDirector.Text = part.Director
        txtPrice.Text = part.Price.ToString()
    End Sub
 
    Public Function ApplyChanges(ByVal controlToEdit As Control) As Boolean Implements ITemplatedEditorPart.ApplyChanges
        Dim success As Boolean = False
        Page.Validate()
        If Page.IsValid Then
            Dim part As ASP.FeaturedVideoPart = CType(controlToEdit, ASP.FeaturedVideoPart)
            part.VideoTitle = txtVideoTitle.Text
            part.Director = txtDirector.Text
            part.Price = Decimal.Parse(txtPrice.Text)
            success = True
        End If
        Return success
    End Function

</script>

<asp:Label
    id="lblVideoTitle"
    Text="Video Title:"
    AssociatedControlID="txtVideoTitle"
    Runat="server" />
<br />
<asp:TextBox
    id="txtVideoTitle"
    Runat="server" />

<br /><br />

<asp:Label
    id="lblDirector"
    Text="Director:"
    AssociatedControlID="txtDirector"
    Runat="server" />
<br />
<asp:TextBox
    id="txtDirector"
    Runat="server" />

<br /><br />

<asp:Label
    id="lblPrice"
    Text="Price:"
    AssociatedControlID="txtPrice"
    Runat="server" />
<br />
<asp:TextBox
    id="txtPrice"
    Runat="server" />
<asp:CompareValidator
    id="valprice"
    ControlToValidate="txtPrice"
    Display="dynamic"
    Text="(Must be Currency)"
    Type="Currency"
    Operator="DataTypeCheck"
    Runat="server" />    
<asp:RequiredFieldValidator ID="RequiredFieldValidator1"
    ControlToValidate="txtPrice"
    Display="dynamic"
    Text="(Required)"
    Runat="server" />    
