Imports System
Imports System.Web.UI
Imports System.Web.UI.WebControls

Namespace myControls
    Public Class ServerTimeButton
        Inherits WebControl
        Implements ICallbackEventHandler

        ''' <summary>
        ''' Add the onclick attribute that initiates the AJAX call
        ''' </summary>
        Protected Overrides Sub AddAttributesToRender(ByVal writer As HtmlTextWriter)
            Dim eRef As String = Page.ClientScript.GetCallbackEventReference( _
                Me, _
                Nothing, _
                "showResult", _
                Nothing, _
                "showError", _
                False)

            writer.AddAttribute(HtmlTextWriterAttribute.Onclick, eRef)
            MyBase.AddAttributesToRender(writer)
        End Sub

        ''' <summary>
        ''' Add the Javascript file that process the AJAX call results
        ''' to the page
        ''' </summary>
        Protected Overrides Sub OnPreRender(ByVal e As EventArgs)
            Page.ClientScript.RegisterClientScriptInclude("serverTimeButton", Page.ResolveClientUrl("~/ClientScripts/ServerTimeButton.js"))
        End Sub

        Protected Overrides Sub RenderContents(ByVal writer As HtmlTextWriter)
            writer.Write("Show Server Time")
        End Sub

        Protected Overrides ReadOnly Property TagKey() As HtmlTextWriterTag
            Get
                Return HtmlTextWriterTag.Button
            End Get
        End Property

        ''' <summary>
        ''' Called on server by AJAX
        ''' </summary>
        ''' <param name="eventArgument"></param>
        Public Sub RaiseCallbackEvent(ByVal eventArgument As String) Implements ICallbackEventHandler.RaiseCallbackEvent
        End Sub

        ''' <summary>
        ''' Returns result back to AJAX call
        ''' </summary>
        ''' <returns></returns>
        Public Function GetCallbackResult() As String Implements ICallbackEventHandler.GetCallbackResult
            'throw new Exception("Server Exception");
            Return DateTime.Now.ToString()
        End Function
    End Class
End Namespace
