Imports System
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.ComponentModel

Namespace myControls

    <ParseChildren(False)> _
    Public Class WebWindow
        Inherits WebControl
        Implements IPostBackEventHandler

        Private _windowTitleText As String = "Untitled"

        Public Event Closed As EventHandler

        Public Property WindowTitleText() As String
            Get
                Return _windowTitleText
            End Get
            Set(ByVal Value As String)
                _windowTitleText = value
            End Set
        End Property

        Protected Overrides Sub OnPreRender(ByVal e As EventArgs)
            If Not Page.ClientScript.IsClientScriptIncludeRegistered("WebWindow") Then
                Page.ClientScript.RegisterClientScriptInclude("WebWindow", Page.ResolveClientUrl("~/ClientScripts/WebWindow.js"))
            End If

            Dim startupScript As String = String.Format("WebWindow.init('{0}');", Me.ClientID)
            Page.ClientScript.RegisterStartupScript(Me.GetType(), Me.ClientID, startupScript, True)
        End Sub

        Protected Overrides Sub RenderContents(ByVal writer As HtmlTextWriter)
            RenderTitleBar(writer)
            writer.AddAttribute(HtmlTextWriterAttribute.Class, "webWindowBody")
            writer.RenderBeginTag(HtmlTextWriterTag.Div)
            Me.RenderChildren(writer)
            writer.RenderEndTag()
        End Sub

        Private Sub RenderTitleBar(ByVal writer As HtmlTextWriter)
            writer.AddAttribute(HtmlTextWriterAttribute.Class, "webWindowTitleBar")
            writer.AddAttribute("onmousedown", "WebWindow.mouseDown(event)")
            writer.AddStyleAttribute(HtmlTextWriterStyle.TextAlign, "right")
            writer.RenderBeginTag(HtmlTextWriterTag.Div)

            writer.AddAttribute(HtmlTextWriterAttribute.Class, "webWindowTitleText")
            writer.RenderBeginTag(HtmlTextWriterTag.Span)
            writer.Write(_windowTitleText)
            writer.RenderEndTag()

            RenderCloseButton(writer)

            writer.RenderEndTag()
        End Sub

        Private Sub RenderCloseButton(ByVal writer As HtmlTextWriter)
            Dim eventRef As String = Page.ClientScript.GetPostBackEventReference(Me, String.Empty)
            writer.AddAttribute(HtmlTextWriterAttribute.Class, "webWindowClose")
            writer.AddAttribute(HtmlTextWriterAttribute.Onclick, eventRef)
            writer.RenderBeginTag(HtmlTextWriterTag.Span)
            writer.Write("X")
            writer.RenderEndTag()
        End Sub

        Protected Overrides Sub AddAttributesToRender(ByVal writer As HtmlTextWriter)
            writer.AddStyleAttribute(HtmlTextWriterStyle.Position, "absolute")
            writer.AddAttribute(HtmlTextWriterAttribute.Class, "webWindow")
            MyBase.AddAttributesToRender(writer)
        End Sub

        Protected Overrides ReadOnly Property TagKey() As HtmlTextWriterTag
            Get
                Return HtmlTextWriterTag.Div
            End Get
        End Property

        Public Sub RaisePostBackEvent(ByVal eventArgument As String) Implements IPostBackEventHandler.RaisePostBackEvent
            RaiseEvent Closed(Me, EventArgs.Empty)
        End Sub
    End Class
End Namespace

