<%@ Control Language="C#" ClassName="AddressForm" %>
<script runat="server">

    public event EventHandler Copy;


    /// <summary>
    /// When Copy checkbox checked, copy billing address
    /// to shipping address
    /// </summary>
    protected void chkCopy_CheckedChanged(object sender, EventArgs e)
    {
        if (Copy != null)
            Copy(this, EventArgs.Empty);
    }
    
    public bool ShowCopyCheckBox
    {
        get { return pnlCopy.Visible; }
        set { pnlCopy.Visible = true; }
    }

    public string CopyCheckBoxText
    {
        get { return chkCopy.Text; }
        set { chkCopy.Text = value; }
    }

    public bool CopyChecked
    {
        get { return chkCopy.Checked; }
    }
    
    public string Street
    {
        get { return txtStreet.Text; }
        set { txtStreet.Text = value; }
    }

    public string City
    {
        get { return txtCity.Text; }
        set { txtCity.Text = value; }
    }

    public string State
    {
        get { return txtState.Text; }
        set { txtState.Text = value; }
    }
    
    public string PostalCode
    {
        get { return txtPostalCode.Text; }
        set { txtPostalCode.Text = value; }
    }

    public string Country
    {
        get { return txtCountry.Text; }
        set { txtCountry.Text = value; }
    }
    
</script>

<asp:Panel
    id="pnlCopy"
    Visible="false"
    Runat="server">
<asp:CheckBox
    id="chkCopy"
    ToolTip="Checking reloads this page"
    AutoPostBack="true"
    CausesValidation="false"
    OnCheckedChanged="chkCopy_CheckedChanged" 
    Runat="server" />
    <br /><br />
</asp:Panel>

<asp:Label
    id="lblStreet"
    Text="Street Address:"
    AssociatedControlId="txtStreet"
    Runat="server" />
<asp:RequiredFieldValidator
    id="reqStreet"
    ControlToValidate="txtStreet"
    Text="(Required)"
    Runat="server" />
<br />
<asp:TextBox
    id="txtStreet"
    AutoCompleteType="HomeStreetAddress"
    TextMode="MultiLine"
    Columns="40"
    Rows="2"
    Runat="server" />
<br /><br />
<div style="float:left;width:200px">
<asp:Label
    id="lblCity"
    Text="City:"
    AssociatedControlId="txtCity"
    Runat="server" />
<asp:RequiredFieldValidator
    id="reqCity"
    ControlToValidate="txtCity"
    Text="(Required)"
    Runat="server" />
<br />
<asp:TextBox
    id="txtCity"
    AutoCompleteType="homecity"
    Columns="20"
    Runat="server" />
</div>
<div style="float:left;width">
<asp:Label
    id="lblState"
    Text="State/Region:"
    AssociatedControlId="txtState"
    Runat="server" />
<asp:RequiredFieldValidator
    id="reqState"
    ControlToValidate="txtState"
    Text="(Required)"
    Runat="server" />
<br />
<asp:TextBox
    id="txtState"
    AutoCompleteType="HomeState"
    Columns="4"
    Runat="server" />
</div>
<br style="clear:both" /><br />


<div style="float:left;width:200px">
<asp:Label
    id="lblPostalCode"
    Text="Postal Code:"
    AssociatedControlId="txtPostalCode"
    Runat="server" />
<asp:RequiredFieldValidator
    id="reqPostalCode"
    ControlToValidate="txtPostalCode"
    Text="(Required)"
    Runat="server" />
<br />
<asp:TextBox
    id="txtPostalCode"
    AutoCompleteType="homezipcode"
    Columns="10"
    Runat="server" />
</div>

<div style="float:left">
<asp:Label
    id="lblCountry"
    Text="Country:"
    AssociatedControlId="txtCountry"
    Runat="server" />
<asp:RequiredFieldValidator
    id="reqCountry"
    ControlToValidate="txtCountry"
    Text="(Required)"
    Runat="server" />
<br />
<asp:TextBox
    id="txtCountry"
    AutoCompleteType="homecountryregion"
    Text="United States"
    Columns="20"
    Runat="server" />
</div>