<%@ Application Language="C#" %>
<%@ Import Namespace="AspNetUnleashed" %>
<script runat="server">


    
    /// <summary>
    /// When the application starts, add the Admin user and 
    /// StoreAdmins role.
    /// </summary>
    void Application_Start(object sender, EventArgs e) 
    {
        MembershipCreateStatus status = new MembershipCreateStatus();
        if (!Roles.RoleExists("StoreAdmins"))
            Roles.CreateRole("StoreAdmins");
        if (Membership.GetUser("Admin") == null)
            Membership.CreateUser("Admin", "secret", "", "dog", "rover", true, out status);
        if (!Roles.IsUserInRole("Admin", "StoreAdmins"))
            Roles.AddUserToRole("Admin", "StoreAdmins");
            
        SiteMap.SiteMapResolve += new SiteMapResolveEventHandler(SiteMap_SiteMapResolve);
    }

    /// <summary>
    /// Return correct SiteMapNode for Category when visiting the
    /// ProductDetails.aspx page.
    /// </summary>
    SiteMapNode SiteMap_SiteMapResolve(object sender, SiteMapResolveEventArgs e)
    {
        if (!String.IsNullOrEmpty(e.Context.Request.QueryString["pid"]))
        {
            int productId = Int32.Parse(e.Context.Request.QueryString["pid"]);
            int categoryId = Category.SelectIdByProductId(productId);
            SiteMapNode node = e.Provider.FindSiteMapNodeFromKey(categoryId.ToString());
            return node;
        }
        return SiteMap.CurrentNode;
    }

    /// <summary>
    /// When an anonymous user logins, modify shopping cart items to
    /// reflect authenticated user name.
    /// </summary>
    public void Profile_OnMigrateAnonymous(object sender, ProfileMigrateEventArgs args)
    {
        ShoppingCart.AuthenticateCart(args.AnonymousID, User.Identity.Name);
        AnonymousIdentificationModule.ClearAnonymousIdentifier();
    }

       
</script>
