<%@ Page Language="C#" MasterPageFile="~/Store.master" Title="Product" %>
<%@ Import Namespace="AspNetUnleashed" %>
<script runat="server">
    
    /// <summary>
    /// Add item to shopping cart
    /// </summary>
    protected void lnkAddCart_Click(object sender, EventArgs e)
    {
        int productId = Int32.Parse(Request.QueryString["pid"]);
        ShoppingCart.Insert(productId);
    }

    protected void srcProduct_Selected(object sender, ObjectDataSourceStatusEventArgs e)
    {
        Trace.Warn("Retreiving product from database");
    }
</script>
<asp:Content ID="Content1" ContentPlaceHolderID="contentMiddle" Runat="Server">
<asp:FormView
    id="frmProduct"
    DataSourceID="srcProduct"
    Runat="server">
    <ItemTemplate>
    
    <div class="fullProductName">
    <%# Eval("Name") %>
    </div>
    Price: <%# Eval("Price", "{0:c}") %>
<br /><br />
<asp:Image
    id="imgProduct"
    Visible='<%# Eval("HasImage") %>'
    ImageUrl='<%# Eval("Id", "~/ProductImage.ashx?id={0}") %>'
    style="width:300px"
    Runat="server" />

    <br /><br />
    <%# String.IsNullOrEmpty((string)Eval("FullDescription")) ? Eval("Description"):Eval("FullDescription") %>
    
    <br /><br />
    <asp:LinkButton
        id="lnkAddCart"
        Text="Add to Cart"
        Runat="server" OnClick="lnkAddCart_Click" />

    </ItemTemplate>    
</asp:FormView>

<asp:ObjectDataSource
    id="srcProduct"
    TypeName="AspNetUnleashed.Product"
    SelectMethod="Select"
    EnableCaching="true"
    SqlCacheDependency="StoreDB:Products"
    OnSelected="srcProduct_Selected"
    Runat="server">
    <SelectParameters>
    <asp:QueryStringParameter Name="Id" QueryStringField="pid" Type="int32" />
    </SelectParameters>
</asp:ObjectDataSource>

</asp:Content>

