<%@ Page Language="C#" MasterPageFile="~/Store.master" Title="Shopping Cart" %>

<script runat="server">

    private decimal _total = 0;

    /// <summary>
    /// Calculate running total as rows are bound to the GridView
    /// </summary>
    protected void grdShoppingCart_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            decimal price = (decimal)DataBinder.Eval(e.Row.DataItem, "Price");
            int quantity = (int)DataBinder.Eval(e.Row.DataItem, "Quantity");
            _total += (price * quantity);
        }
    }    
    
    /// <summary>
    /// Show price total and check out link
    /// </summary>
    protected void grdShoppingCart_DataBound(object sender, EventArgs e)
    {
        if (_total == 0)
            lnkCheckOut.Visible = false;
        else
        {
            Label lblTotal = (Label)grdShoppingCart.FooterRow.FindControl("lblTotal");
            lblTotal.Text = _total.ToString("c");
        }
    }

</script>

<asp:Content ID="Content1" ContentPlaceHolderID="contentMiddle" Runat="Server">


<asp:GridView
    id="grdShoppingCart"
    DataSourceID="srcCart"
    DataKeyNames="id"
    AutoGenerateColumns="false"
    AutoGenerateDeleteButton="true"
    EmptyDataText="There are no items in your shopping cart. Login to view your saved shopping cart."
    CssClass="cartBig"
    AlternatingRowStyle-CssClass="cartAlternating"
    GridLines="none"
    ShowFooter="true"
    Runat="server" OnDataBound="grdShoppingCart_DataBound" OnRowDataBound="grdShoppingCart_RowDataBound">
    <Columns>
    
    <asp:BoundField DataField="Name" HeaderText="Product Name" />
    <asp:BoundField DataField="Quantity" HeaderText="Quantity" />
    <asp:TemplateField HeaderText="Price" FooterStyle-CssClass="cartTotalFooter">
    <ItemTemplate>
    <%# Eval("Price", "{0:c}") %>
    </ItemTemplate>
    <FooterTemplate>
    <asp:Label
        id="lblTotal"
        Runat="server" />
    </FooterTemplate>
    </asp:TemplateField>
    
    </Columns>
</asp:GridView>


<br /><br />
    
    
<asp:Hyperlink
    id="lnkCheckOut"
    Text="Check Out"
    NavigateUrl="~/CheckOut/Default.aspx"
    Runat="server" />


<asp:ObjectDataSource
    id="srcCart"
    TypeName="AspNetUnleashed.ShoppingCart"
    SelectMethod="Select"
    DeleteMethod="Delete"
    Runat="server" />


</asp:Content>

<asp:Content ContentPlaceHolderID="contentRight" runat="server" />