<%@ Control Language="C#" ClassName="CategoryView" %>
<%@ OutputCache Duration="99999" Shared="true" VaryByParam="id" SqlDependency="StoreDB:Categories" %>

<script runat="server">

    /// <summary>
    /// Get child Categories of current SiteMapNode
    /// </summary>
    protected void srcCategories_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        e.InputParameters["id"] = SiteMap.CurrentNode.Key;
        Trace.Warn("Retrieving categories from database");
    }
    
</script>


<asp:DataList
    id="dlstCategories"
    DataSourceID="srcCategories"
    RepeatColumns="2"
    CssClass="categoryList"
    Runat="server">
    <ItemTemplate>
    <user:CategoryTemplate
        id="CategoryTemplate1"
        Runat="server" />
    </ItemTemplate>
</asp:DataList>


<asp:ObjectDataSource
    id="srcCategories"
    TypeName="AspNetUnleashed.Category"
    SelectMethod="SelectChildren"
    Runat="server" OnSelecting="srcCategories_Selecting">
    <SelectParameters>
    <asp:Parameter Name="Id" Type="Int32" />
    </SelectParameters>    
</asp:ObjectDataSource>

