Imports System
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
 
Namespace AspNetUnleashed
 
    ''' <summary>
    ''' Unhides a WebWindow by setting its 
    ''' display attribute to block
    ''' </summary>
    Public Class OpenWebWindow
	 Inherits WebControl
 
        Private _webWindowID As String
        Private _text As String =  "Open Window" 
 
        ''' <summary>
        ''' The ID of the WebWindow to display
        ''' </summary>
        Public Property WebWindowID() As String
        	Get 
            	 Return _webWindowID
        	End Get
        	Set (ByVal Value As String) 
            	 _webWindowID = value
        	End Set
        End Property
 
        ''' <summary>
        ''' The text that appears on the link
        ''' </summary>
        Public Property Text() As String
        	Get 
            	 Return _text
        	End Get
        	Set (ByVal Value As String) 
            	 _text = value
        	End Set
        End Property
 
        ''' <summary>
        ''' Add the client onclick handler for
        ''' opening the WebWindow
        ''' </summary>
        Protected Overrides  Sub AddAttributesToRender(ByVal writer As HtmlTextWriter)
            ' Create the open script
            Dim webWindow As Control = Me.NamingContainer.FindControl(_webWindowID) 
            If webWindow Is Nothing Then
                Throw New Exception("Could not find WebWindow with ID " & _webWindowID)
            End If
            Dim webWindowClientId As String =  webWindow.ClientID 
            Dim openScript As String =  String.Format("document.getElementById('{0}').style.display='block'",webWindowClientId) 
 
            ' Add the attributes
            writer.AddAttribute(HtmlTextWriterAttribute.Href, "javascript:void(0)")
            writer.AddAttribute(HtmlTextWriterAttribute.Onclick, openScript)
            MyBase.AddAttributesToRender(writer)
        End Sub
 
        ''' <summary>
        ''' Display the label for the link
        ''' </summary>
        Protected Overrides  Sub RenderContents(ByVal writer As HtmlTextWriter)
            writer.Write(_text)
        End Sub
 
        ''' <summary>
        ''' Render this control as a hyperlink
        ''' </summary>
        Protected Overrides ReadOnly Property TagKey() As HtmlTextWriterTag
        	Get 
                Return HtmlTextWriterTag.A
        	End Get
        End Property
 
    End Class
End Namespace
