Imports System
Imports System.Security.Cryptography
Imports System.IO
Imports System.Text
Imports System.Web.Configuration
 
 
Namespace AspNetUnleashed
 
    ''' <summary>
    ''' Encrypts and decrypts strings by
    ''' using the Rijndael (AES) algorithm
    ''' </summary>
    Public Class Secret
        Const Salt As String = "This is secret!"
 
        Private Shared ReadOnly Key() As Byte
        Private Shared ReadOnly IV() As Byte
 
        ''' <summary>
        ''' Encrypt a string using the machineKey decryptionKey
        ''' attribute from the Web configuration file
        ''' </summary>
        Public Shared Function Encrypt(ByVal text As String) As Byte()
            'Get an encryptor.
            Dim myRijndael As New RijndaelManaged()
            Dim encryptor As ICryptoTransform = myRijndael.CreateEncryptor(Key, IV)

            'Encrypt the data.
            Dim msEncrypt As New MemoryStream()
            Dim csEncrypt As New CryptoStream(msEncrypt, encryptor, CryptoStreamMode.Write)

            'Convert the data to a byte array.
            Dim toEncrypt() As Byte = Encoding.ASCII.GetBytes(text)

            'Write all data to the crypto stream and flush it.
            csEncrypt.Write(toEncrypt, 0, toEncrypt.Length)
            csEncrypt.FlushFinalBlock()

            'Get encrypted array of bytes.
            Return msEncrypt.ToArray()
        End Function

        ''' <summary>
        ''' Decrypts a string
        ''' </summary>
        Public Shared Function Decrypt(ByVal encrypted() As Byte) As String
            Dim myRijndael As New RijndaelManaged()

            'Get a decryptor that uses the same key and IV as the encryptor.
            Dim decryptor As ICryptoTransform = myRijndael.CreateDecryptor(Key, IV)

            ' Decrypt into memory stream
            Dim msDecrypt As New MemoryStream(encrypted)
            Dim csDecrypt As New CryptoStream(msDecrypt, decryptor, CryptoStreamMode.Read)

            Dim fromEncrypt() As Byte = New Byte(encrypted.Length) {}

            'Read the data out of the crypto stream.
            Try
                csDecrypt.Read(fromEncrypt, 0, fromEncrypt.Length)
            Catch
                Return "?????"
            End Try

            'Convert the byte array back into a string.
            Return Encoding.ASCII.GetString(fromEncrypt)
        End Function


        ''' <summary>
        ''' Load decryptionKey from machineKey section of the Web configuration file
        ''' </summary>
        Shared Sub New()
            ' Get the encryption key
            Dim section As MachineKeySection = CType(WebConfigurationManager.GetWebApplicationSection("system.web/machineKey"), MachineKeySection)
            If section.DecryptionKey Is Nothing Then
                Throw New Exception("You must specify a decryptionKey in the Web configuration file")
            End If
            Dim decryptionKey As String = section.DecryptionKey

            ' Derive the encryption Key and IV
            Dim bSalt() As Byte = Encoding.ASCII.GetBytes(Salt)
            Dim pdb As New Rfc2898DeriveBytes(decryptionKey, bSalt)
            Key = pdb.GetBytes(32)
            IV = pdb.GetBytes(16)
        End Sub

    End Class
End Namespace

