<%@ Application Language="VB" %>
<%@ Import Namespace="AspNetUnleashed" %>
<script runat="server">
 
    ''' <summary>
    ''' When the application starts, add the Admin user and 
    ''' StoreAdmins role.
    ''' </summary>
    Private  Sub Application_Start(ByVal sender As Object, ByVal e As EventArgs)
        Dim status As New MembershipCreateStatus()
        If Not Roles.RoleExists("StoreAdmins") Then
            Roles.CreateRole("StoreAdmins")
        End If
        If Membership.GetUser("Admin") Is Nothing Then
            Membership.CreateUser("Admin", "secret", "", "dog", "rover", True, status)
        End If
        If Not Roles.IsUserInRole("Admin","StoreAdmins") Then
            Roles.AddUserToRole("Admin", "StoreAdmins")
        End If
        AddHandler SiteMap.SiteMapResolve, AddressOf SiteMap_SiteMapResolve
    End Sub
 
    ''' <summary>
    ''' Return correct SiteMapNode for Category when visiting the
    ''' ProductDetails.aspx page.
    ''' </summary>
    Private Function SiteMap_SiteMapResolve(ByVal sender As Object, ByVal e As SiteMapResolveEventArgs) As SiteMapNode
        If Not String.IsNullOrEmpty(e.Context.Request.QueryString("pid")) Then
            Dim productId As Integer =  Int32.Parse(e.Context.Request.QueryString("pid")) 
            Dim categoryId As Integer =  Category.SelectIdByProductId(productId) 
            Dim node As SiteMapNode =  e.Provider.FindSiteMapNodeFromKey(categoryId.ToString()) 
            Return node
        End If
        Return SiteMap.CurrentNode
    End Function
 
    ''' <summary>
    ''' When an anonymous user logins, modify shopping cart items to
    ''' reflect authenticated user name.
    ''' </summary>
    Public  Sub Profile_OnMigrateAnonymous(ByVal sender As Object, ByVal args As ProfileMigrateEventArgs)
        ShoppingCart.AuthenticateCart(args.AnonymousID, User.Identity.Name)
        AnonymousIdentificationModule.ClearAnonymousIdentifier()
    End Sub

       
</script>
