<%@ Page Language="VB" MasterPageFile="~/Manage/Manage.master" Title="Manage Product Categories" ValidateRequest="false" %>
<%@ Import Namespace="AspNetUnleashed" %>
<script runat="server">
 
    ''' <summary>
    ''' Hide the WebWindow after Cancel or Insert command
    ''' </summary>
    Protected  Sub frmAdd_ItemCommand(ByVal sender As Object, ByVal e As FormViewCommandEventArgs)
        winAdd.Hide = True
    End Sub
 
    ''' <summary>
    ''' Reload Site Map after the Categories are updated
    ''' </summary>
    Protected  Sub frmAdd_ItemInserted(ByVal sender As Object, ByVal e As FormViewInsertedEventArgs)
        ResetSiteMap()
    End Sub
 
    ''' <summary>
    ''' Grab the CategorySiteMapProvider and call its ResetSiteMap() method
    ''' </summary>
    Private  Sub ResetSiteMap()
        Dim provider As CategorySiteMapProvider = CType(SiteMap.Providers("CategorySiteMapProvider"), CategorySiteMapProvider)
        provider.ResetSiteMap()
 
        Dim selectedPath As String =  treeCategories.SelectedNode.ValuePath 
        treeCategories.DataBind()
        treeCategories.FindNode(selectedPath).Select()
    End Sub
 
    ''' <summary>
    ''' Select the first node in the TreeView by default
    ''' </summary>
    Protected  Sub treeCategories_DataBound(ByVal sender As Object, ByVal e As EventArgs)
        treeCategories.Nodes(0).Select()
    End Sub
 
    ''' <summary>
    ''' When a category is deleted, reset Site Map
    ''' </summary>
    Protected  Sub grdCategories_RowDeleted(ByVal sender As Object, ByVal e As GridViewDeletedEventArgs)
        ResetSiteMap()
    End Sub
 
    ''' <summary>
    ''' When you select a Category, show the edit Window
    ''' </summary>
    Protected  Sub grdCategories_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        winEdit.Hide = False
    End Sub
 
    ''' <summary>
    ''' Hide the Edit window when Cancel or Update is clicked
    ''' </summary>
    Protected  Sub frmEdit_ItemCommand(ByVal sender As Object, ByVal e As FormViewCommandEventArgs)
        winEdit.Hide = True
    End Sub
 
    ''' <summary>
    ''' Reset Site Map after editing a category
    ''' </summary>
    Protected  Sub frmEdit_ItemUpdated(ByVal sender As Object, ByVal e As FormViewUpdatedEventArgs)
        ResetSiteMap()
        grdCategories.DataBind()
    End Sub

</script>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">

<div style="padding:15px">
Use this page to manage product categories. You can add new product categories, delete categories and
edit existing categories.
</div>

<div style="width:800px">
<div style="float:left;margin-right:10px;padding:10px;border-right:solid 1px black;">


<asp:TreeView
    id="treeCategories"
    ImageSet="Msdn"
    DataSourceID="srcSiteMap"
    AutoGenerateDataBindings="false"
    SelectedNodeStyle-BackColor="#CCCCCC"
    Runat="server" OnDataBound="treeCategories_DataBound">
    <DataBindings>
    <asp:TreeNodeBinding TextField="Title" ValueField="Key" SelectAction="Select" />
    </DataBindings>
    </asp:TreeView>

<asp:SiteMapDataSource
    id="srcSiteMap"
    StartingNodeUrl="~/Products.aspx"
    Runat="server" />




</div>
<div style="float:left">


<asp:GridView
    id="grdCategories"
    DataSourceID="srcCategories"
    DataKeyNames="Id"
    AutoGenerateColumns="false"
    CssClass="grid"
    GridLines="None"
    Runat="server" OnRowDeleted="grdCategories_RowDeleted" OnSelectedIndexChanged="grdCategories_SelectedIndexChanged">
    <Columns>
    <asp:TemplateField>
    <ItemTemplate>
        <asp:LinkButton
            id="lnkEdit"
            Text="Edit"
            CommandName="Select"
            Runat="server" />
        /
        <asp:LinkButton
            id="LinkButton1"
            Text="Delete"
            CommandName="Delete"
            OnClientClick="return confirm('Are you sure that you want to delete this category and all subcategories?');"
            Runat="server" />
    </ItemTemplate>
    </asp:TemplateField>
     <asp:BoundField
        DataField="Title"
        HeaderText="Title" />
    <asp:BoundField
        DataField="Description"
        HeaderText="Description" />     
    </Columns>
</asp:GridView>    
<br />
<custom:OpenWebWindow
    id="lnkAdd"
    Text="Add Category"
    WebWindowID="winAdd"
    Runat="server"/>


<custom:WebWindow
    id="winAdd"
    WindowTitleText="Add Product Category"
    Hide="true"
    Runat="server">
    
    <asp:FormView
        id="frmAdd"
        DataSourceID="srcCategories"
        DefaultMode="Insert"
        OnItemCommand="frmAdd_ItemCommand" 
        OnItemInserted="frmAdd_ItemInserted"
        Runat="server">
        <InsertItemTemplate>
        <asp:Label
            id="lblTitle"
            Text="Title:"
            AssociatedControlID="txtTitle"
            Runat="server" />
        <asp:RequiredFieldValidator
            id="reqTitle"
            ControlToValidate="txtTitle"
            Text="(Required)"
            ValidationGroup="Add"
            Runat="server" />    
        <br />
        <asp:TextBox
            id="txtTitle"
            Text='<%# Bind("Title") %>'
            Runat="server" />
        <br /><br />
        <asp:Label
            id="lblDescription"
            Text="Brief Description:"
            AssociatedControlID="txtDescription"
            Runat="server" />
        <asp:RequiredFieldValidator
            id="reqDescription"
            ControlToValidate="txtDescription"
            Text="(Required)"
            ValidationGroup="Add"
            Runat="server" />    
        <br />
        <asp:TextBox
            id="txtDescription"
            Text='<%# Bind("Description") %>'
            Columns="40"
            Runat="server" />
        <br /><br />
        <asp:Label
            id="lblFullDescription"
            Text="Full Description (can include HTML):"
            AssociatedControlID="txtFullDescription"
            Runat="server" />
        <br />
        <asp:TextBox
            id="txtFullDescription"
            Text='<%# Bind("FullDescription") %>'
            TextMode="MultiLine"
            Columns="40"
            Rows="8"
            Runat="server" />
        <br /><br />
        <asp:Button
            id="btnAdd"
            Text="Add"
            CommandName="Insert"
            ValidationGroup="Add"
            Runat="server" />        
        <asp:Button
            id="btnCancel"
            Text="Cancel"
            CommandName="Cancel"
            CausesValidation="false"
            Runat="server" />        
    </InsertItemTemplate>
    </asp:FormView>
       
</custom:WebWindow>



<custom:WebWindow
    id="winEdit"
    Hide="true"
    Runat="server">
    
    <asp:FormView
        id="frmEdit"
        DataSourceID="srcEditCategories"
        DefaultMode="Edit"
        Runat="server" OnItemCommand="frmEdit_ItemCommand" OnItemUpdated="frmEdit_ItemUpdated">
        <EditItemTemplate>
        <asp:Label
            id="lblTitle"
            Text="Title:"
            AssociatedControlID="txtTitle"
            Runat="server" />
        <asp:RequiredFieldValidator
            id="reqTitle"
            ControlToValidate="txtTitle"
            Text="(Required)"
            ValidationGroup="Edit"
            Runat="server" />    
        <br />
        <asp:TextBox
            id="txtTitle"
            Text='<%# Bind("Title") %>'
            Runat="server" />
        <br /><br />
        <asp:Label
            id="lblDescription"
            Text="Brief Description:"
            AssociatedControlID="txtDescription"
            Runat="server" />
        <asp:RequiredFieldValidator
            id="reqDescription"
            ControlToValidate="txtDescription"
            Text="(Required)"
            ValidationGroup="Edit"
            Runat="server" />    
        <br />
        <asp:TextBox
            id="txtDescription"
            Text='<%# Bind("Description") %>'
            Columns="40"
            Runat="server" />
        <br /><br />
        <asp:Label
            id="lblFullDescription"
            Text="Full Description (can include HTML):"
            AssociatedControlID="txtFullDescription"
            Runat="server" />
        <br />
        <asp:TextBox
            id="txtFullDescription"
            Text='<%# Bind("FullDescription") %>'
            TextMode="MultiLine"
            Columns="40"
            Rows="8"
            Runat="server" />
        <br /><br />
        <asp:Button
            id="btnEdit"
            Text="Update"
            CommandName="Update"
            ValidationGroup="Edit"
            Runat="server" />        
        <asp:Button
            id="btnCancel"
            Text="Cancel"
            CommandName="Cancel"
            CausesValidation="false"
            Runat="server" />        
        </EditItemTemplate>
    </asp:FormView>
       
</custom:WebWindow>



<asp:ObjectDataSource
    id="srcCategories"
    TypeName="AspNetUnleashed.Category"
    SelectMethod="SelectChildren"
    InsertMethod="Insert"
    DeleteMethod="Delete"
    Runat="server">
    <SelectParameters>
    <asp:ControlParameter Name="Id" ControlID="treeCategories" />
    </SelectParameters>
    <InsertParameters>
    <asp:ControlParameter Name="ParentId" ControlID="treeCategories" />
    </InsertParameters>
 </asp:ObjectDataSource>


<asp:ObjectDataSource
    id="srcEditCategories"
    TypeName="AspNetUnleashed.Category"
    SelectMethod="Select"
    UpdateMethod="Update"
    Runat="server">
    <SelectParameters>
    <asp:ControlParameter Name="Id" ControlID="grdCategories" />
    </SelectParameters>
    <UpdateParameters>
    <asp:ControlParameter Name="Id" ControlID="grdCategories" />
    </UpdateParameters>
</asp:ObjectDataSource>    


</div>

<br style="clear:both" />

</div>



</asp:Content>

