<%@ Page Language="VB" MasterPageFile="~/Manage/Manage.master" Title="Untitled Page" %>

<script runat="server">
 
    Private _total As Decimal =  0 
 
    ''' <summary>
    ''' When an order is selected, show order details in WebWindow
    ''' </summary>
    Protected Sub grdOrders_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        winDetails.Hide = False
    End Sub
 
    ''' <summary>
    ''' Keep a running total
    ''' </summary>
    Protected  Sub grdOrderItems_RowDataBound(ByVal sender As Object, ByVal e As GridViewRowEventArgs)
        If e.Row.RowType = DataControlRowType.DataRow Then
            Dim price As Decimal = CType(DataBinder.Eval(e.Row.DataItem,"Price"), Decimal)
            Dim quantity As Integer = CType(DataBinder.Eval(e.Row.DataItem,"Quantity"), Integer)
            _total += (price * quantity)
        End If
    End Sub
 
    ''' <summary>
    ''' After binding Grid, show the total 
    ''' </summary>
    Protected  Sub grdOrderItems_DataBound(ByVal sender As Object, ByVal e As EventArgs)
        Dim grdOrderItems As GridView = CType(sender, GridView)
        Dim lblTotal As Label = CType(grdOrderItems.FooterRow.FindControl("lblTotal"), Label)
        lblTotal.Text = _total.ToString("c")
    End Sub
 
    ''' <summary>
    ''' When you click Close on the WebWindow, hide the window
    ''' </summary>
    Protected  Sub winDetails_Closed(ByVal sender As Object, ByVal e As EventArgs)
        winDetails.Hide = True
    End Sub


</script>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">

<div style="padding:15px">
Use this page to manage product orders. When a customer submits a shopping cart, the
order appears here.
You can view order details by clicking the 
Select link next to any order.
</div>

<asp:GridView
    id="grdOrders"
    DataSourceID="srcOrders"
    DataKeyNames="Id"
    AutoGenerateColumns="false"
    AutoGenerateSelectButton="true"
    GridLines="None"
    CssClass="grid"
    OnSelectedIndexChanged="grdOrders_SelectedIndexChanged"
    Runat="server">
    <Columns>
    <asp:BoundField DataField="Id" HeaderText="Order Id" />
    <asp:BoundField DataField="CCName" HeaderText="Customer Name" />
    <asp:BoundField DataField="EntryDate" HeaderText="Order Date" />
    </Columns>
</asp:GridView>



<custom:WebWindow
    id="winDetails"
    WindowTitleText="Order Details"
    ShowCloseButton="true"
    Runat="server" OnClosed="winDetails_Closed">
    
    <asp:FormView
        id="frmOrder"
        DataSourceID="srcOrderDetails"
        Runat="server">
        <ItemTemplate>
        <div class="scrollBox" style="height:300px">    
      
        <fieldset>
        <legend>Payment Information</legend>
        
        <div class="leftForm">
        Order Id:
        <br />
        Customer Name:
        <br />
        Credit Card Number:
        <br />
        Credit Card Type:
        </div>
        
        <div class="rightForm">
        <%# Eval("Id") %>
        <br />
        <%# Eval("CCName") %>
        <br />
        <%# Eval("CCNumber") %>
        <br />
        <%# Eval("CCType") %>
        </div>
        <br style="clear:both" />
        </fieldset>
        <br />
        
        <fieldset>
        <legend>Billing Information</legend>
        
        <div class="leftForm">
        Street:
        <br />
        City:
        <br />
        State:
        <br />
        Postal:
        <br />
        Country:
        </div>
        
        <div class="rightForm">
        <%# Eval("BillingStreet") %>
        <br />
        <%# Eval("BillingCity") %>
        <br />
        <%# Eval("BillingState") %>
        <br />
        <%# Eval("BillingPostalCode") %>
        <br />
        <%# Eval("BillingCountry") %>

        </div>
        <br style="clear:both" />
        </fieldset>
        
        <br />
        
        <fieldset>
        <legend>Shipping Information</legend>
        
        <div class="leftForm">
        Street:
        <br />
        City:
        <br />
        State:
        <br />
        Postal:
        <br />
        Country:
        </div>
        
        <div class="rightForm">
        <%# Eval("ShippingStreet") %>
        <br />
        <%# Eval("ShippingCity") %>
        <br />
        <%# Eval("ShippingState") %>
        <br />
        <%# Eval("ShippingPostalCode") %>
        <br />
        <%# Eval("ShippingCountry") %>

        </div>
        <br style="clear:both" />
        </fieldset>

        <br />
        
        <asp:GridView
            id="grdOrderItems"
            DataSourceID="srcOrderItems"
            AutoGenerateColumns="false"
            GridLines="none"
            CssClass="cart"
            AlternatingRowStyle-CssClass="cartAlternating"
            ShowFooter="true"
            Runat="server" OnRowDataBound="grdOrderItems_RowDataBound" OnDataBound="grdOrderItems_DataBound">
            <Columns>
            <asp:BoundField DataField="Name" HeaderText="Name" />
            <asp:BoundField DataField="Quantity" HeaderText="Quantity" />
            <asp:TemplateField HeaderText="Price" FooterStyle-CssClass="cartTotalFooter">
            <ItemTemplate>
            <%# Eval("Price", "{0:c}") %>
            </ItemTemplate>
            <FooterTemplate>
            <asp:Label
                id="lblTotal"
                Runat="server" />
            </FooterTemplate>
            </asp:TemplateField>
            </Columns>
        </asp:GridView>
        <br /><br />
        </div>        
        </ItemTemplate>    
    </asp:FormView>
    
    
</custom:WebWindow>

<asp:ObjectDataSource
    id="srcOrders"
    TypeName="AspNetUnleashed.Order"
    SelectMethod="SelectAll"
    Runat="server" />

<asp:ObjectDataSource
    id="srcOrderDetails"
    TypeName="AspNetUnleashed.Order"
    SelectMethod="Select"
    Runat="server">
    <SelectParameters>
    <asp:ControlParameter Name="Id" ControlID="grdOrders" Type="int32" />
    </SelectParameters>
</asp:ObjectDataSource>

<asp:ObjectDataSource
    id="srcOrderItems"
    TypeName="AspNetUnleashed.Order"
    SelectMethod="SelectOrderItems"
    Runat="server">
    <SelectParameters>
    <asp:ControlParameter Name="OrderId" ControlID="grdOrders" Type="int32" />
    </SelectParameters>
</asp:ObjectDataSource>




</asp:Content>

