<%@ Page Language="VB" MasterPageFile="~/Manage/Manage.master" Title="Manage Products" ValidateRequest="false" %>

<script runat="server">

 
    ''' <summary>
    ''' After adding a product, hide the WebWindow
    ''' </summary>
    Sub frmAdd_ItemInserted(ByVal sender As Object, ByVal e As FormViewInsertedEventArgs)
        winAdd.Hide = True
    End Sub
 
    ''' <summary>
    ''' After clicking Cancel, hide the WebWindow
    ''' </summary>
    Sub frmAdd_ItemCommand(ByVal sender As Object, ByVal e As FormViewCommandEventArgs)
        winAdd.Hide = True
    End Sub
 
    ''' <summary>
    ''' Add a new product and image to the database
    ''' </summary>
    Sub srcProducts_Inserted(ByVal sender As Object, ByVal e As ObjectDataSourceStatusEventArgs)
        ' Get new product Id
        Dim NewProductId As Integer = CType(e.ReturnValue, Integer)
 
        ' Save product image
        Dim upImage As FileUpload = CType(frmAdd.FindControl("upImage"), FileUpload)
        If upImage.HasFile Then
            Product.InsertImage(NewProductId, upImage.FileContent)
        End If
    End Sub
 
    ''' <summary>
    ''' When a product is seleced, open the Product in a separate 
    ''' WebWindow for editing
    ''' </summary>
    Sub grdProducts_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        winEdit.Hide = False
    End Sub
 
    ''' <summary>
    ''' Hide the Edit WebWindow after clicking Cancel or Update
    ''' </summary>
    Sub frmEdit_ItemCommand(ByVal sender As Object, ByVal e As FormViewCommandEventArgs)
        winEdit.Hide = True
    End Sub
 
    ''' <summary>
    ''' Update a Product in the database
    ''' </summary>
    Sub srcEditProducts_Updated(ByVal sender As Object, ByVal e As ObjectDataSourceStatusEventArgs)
        ' Get product Id
        Dim productId As Integer = CType(grdProducts.SelectedValue, Integer)
 
        ' Save product image
        Dim upImage As FileUpload = CType(frmEdit.FindControl("upImage"), FileUpload)
        If (upImage.HasFile) Then
            Product.InsertImage(productId, upImage.FileContent)
        End If
        ' Refresh GridView
        grdProducts.DataBind()
    End Sub
 
    ''' <summary>
    ''' Rebind products after a product is deleted
    ''' </summary>
    Sub srcEditProducts_Deleted(ByVal sender As Object, ByVal e As ObjectDataSourceStatusEventArgs)
        grdProducts.DataBind()
    End Sub


</script>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">

<div style="padding:10px">
Use this page to manage your product inventory. You can add, delete, and edit existing products.
</div>


<asp:GridView
    id="grdProducts"
    DataSourceID="srcProducts"
    DataKeyNames="Id"
    AutoGenerateColumns="false"
    GridLines="None"
    CssClass="grid"
    OnSelectedIndexChanged="grdProducts_SelectedIndexChanged"
    runat="server">
    <Columns>
    <asp:TemplateField>
    <ItemTemplate>
        <asp:LinkButton
            id="lnkEdit"
            Text="Edit"
            CommandName="Select"
            Runat="server" />
        /
        <asp:LinkButton
            id="lnkDelete"
            Text="Delete"
            CommandName="Delete"
            OnClientClick="return confirm('Are you sure that you want to delete this product?')"
            Runat="server" />
    </ItemTemplate>
    </asp:TemplateField>
    <asp:BoundField DataField="Id" HeaderText="Id" />
    <asp:HyperLinkField DataTextField="Name" DataNavigateUrlFields="Id" DataNavigateUrlFormatString="~/ProductDetails.aspx?pid={0}" Target="_blank" HeaderText="Name" />
    <asp:BoundField DataField="CategoryTitle" HeaderText="Category" />
    <asp:BoundField DataField="Price" HeaderText="Price" HtmlEncode="false" DataFormatString="{0:c}" />
    <asp:CheckBoxField DataField="IsFeatured" HeaderText="Featured?" />
    </Columns>
</asp:GridView>

<br />
<custom:OpenWebWindow
    id="lnkOpen"
    Text="Add New Product"
    WebWindowID="winAdd"
    Runat="server" />
 

<custom:WebWindow
    id="winAdd"
    WindowTitleText="Add New Product"
    Hide="true"
    ShowCloseButton="false"
    Runat="server">



    <asp:FormView
        id="frmAdd"
        DefaultMode="Insert"
        DataSourceID="srcProducts"
        Runat="server" OnItemInserted="frmAdd_ItemInserted" OnItemCommand="frmAdd_ItemCommand">
        <InsertItemTemplate>
        <div class="scrollBox" style="height:300px">    
        <asp:Label
            id="lblName"
            Text="Name:"
            AssociatedControlID="txtName"
            Runat="server" />
        <asp:RequiredFieldValidator
            id="reqName"
            ControlToValidate="txtName"
            Text="(Required)"
            ValidationGroup="Add"
            Runat="server" />    
        <div class="instructions">
            Enter the name of the product.
        </div>
        <asp:TextBox
            id="txtName"
            Text='<%# Bind("Name") %>'
            Runat="server" />    
        <br /><br />
        <asp:CheckBox
            id="chkIsFeatured"
            Text="Is Featured?"
            Checked='<%# Bind("IsFeatured") %>'
            Runat="server" />
        <div class="instructions">
            Featured products appear on the home page.
        </div>
        <br />
        <div class="colForm">
        <asp:Label
            id="lblCategory"
            Text="Category:"
            AssociatedControlID="dropCategory"
            Runat="server" />
        <div class="instructions">
            Select a product category.
        </div>
        <custom:SiteMapDropDownList
            id="dropCategory"
            StartingNodeUrl="~/Products.aspx"
            SelectedValue='<%# Bind("CategoryId") %>'
            runat="server" />
        </div>    
        <div class="colForm">
        <asp:Label
            id="lblPrice"
            Text="Price:"
            AssociatedControlID="txtPrice"
            Runat="server" />
        <asp:RequiredFieldValidator
            id="reqPrice"
            ControlToValidate="txtPrice"
            Text="(Required)"
            Display="Dynamic"
            ValidationGroup="Add"
            Runat="server" />
        <asp:CompareValidator
            id="valPrice"
            ControlToValidate="txtPrice"
            Text="(Currency)"
            Operator="DataTypeCheck"
            Type="Currency"
            ValidationGroup="Add"
            Display="Dynamic"
            Runat="server" />        
        <div class="instructions">
            Enter the product price. 
        </div>
        <asp:TextBox
            id="txtPrice"
            Columns="5"
            Text='<%# Bind("Price") %>'
            Runat="server" />
        </div>        
        <br style="clear:both" /><br />
        <asp:Label
            id="lblDescription"
            Text="Brief Description (can include HTML):"
            AssociatedControlID="txtDescription"
            Runat="server" />
        <asp:RequiredFieldValidator
            id="reqDescription"
            ControlToValidate="txtDescription"
            Text="(Required)"
            ValidationGroup="Add"
            Runat="server" />    
        <div class="instructions">
            The brief description appears in the Products.aspx
            page and in advertisements.
        </div>
        <asp:TextBox
            id="txtDescription"
            Text='<%#Bind("Description")%>'
            TextMode="multiLine"
            Columns="40"
            Rows="2"
            Runat="server" />    
        <br /><br />
        <asp:Label
            id="lblFullDescription"
            Text="Full Description (can include HTML):"
            AssociatedControlID="txtFullDescription"
            Runat="server" />
        <div class="instructions">
            (Optional)The full description appears on the ProductDetails.aspx
            page. If you don't enter a value
            then the brief description is displayed.
        </div>
        <asp:TextBox
            id="txtFullDescription"
            Text='<%#Bind("FullDescription")%>'
            TextMode="multiLine"
            Columns="40"
            Rows="4"
            Runat="server" />    
        <br /><br />
        <asp:Label
            id="lblImage"
            Text="Image:"
            AssociatedControlID="upImage"
            Runat="server" />
        <div class="instructions">
            (Optional)Upload a product image from your hard drive. 
        </div>
        <asp:FileUpload
            id="upImage"
            Runat="server" />            
        <br /><br />
        <asp:Label
            id="lblImageAltText"
            Text="Image Alt Text:"
            AssociatedControlID="txtImageAltText"
            Runat="server" />
        <div class="instructions">
        Alternate text associated with the product image.
        </div>
        <asp:TextBox
            id="txtImageAltText"
            Text='<%#Bind("ImageAltText")%>'
            Columns="40"
            Runat="server" />
        <br /><br />         
        </div>
        <br />
        <asp:Button 
            id="btnAdd"
            Text="Add Product"
            CommandName="Insert"
            ValidationGroup="Add"
            Runat="server" />
        <asp:Button 
            id="btnCancel"
            Text="Cancel"
            CausesValidation="false"
            CommandName="Cancel"
            Runat="server" />

        </InsertItemTemplate>
    </asp:FormView>

 </custom:WebWindow>

<custom:WebWindow
    id="winEdit"
    WindowTitleText="Edit Product"
    Hide="true"
    ShowCloseButton="false"
    Runat="server">
    <asp:FormView
        id="frmEdit"
        DefaultMode="Edit"
        DataSourceID="srcEditProducts"
        Runat="server" OnItemCommand="frmEdit_ItemCommand">
        <EditItemTemplate>
        <div class="scrollBox" style="height:300px">    
        <asp:Label
            id="lblName"
            Text="Name:"
            AssociatedControlID="txtName"
            Runat="server" />
        <asp:RequiredFieldValidator
            id="reqName"
            ControlToValidate="txtName"
            Text="(Required)"
            ValidationGroup="Add"
            Runat="server" />    
        <div class="instructions">
            Enter the name of the product.
        </div>
        <asp:TextBox
            id="txtName"
            Text='<%# Bind("Name") %>'
            Runat="server" />    
        <br /><br />
        <asp:CheckBox
            id="chkIsFeatured"
            Text="Is Featured?"
            Checked='<%# Bind("IsFeatured") %>'
            Runat="server" />
        <div class="instructions">
            Featured products appear on the home page.
        </div>
        <br />
        <div class="colForm">
        <asp:Label
            id="lblDropCategory"
            Text="Category:"
            AssociatedControlID="dropCategory"
            Runat="server" />
        <div class="instructions">
            Select a product category.
        </div>
        <custom:SiteMapDropDownList
            id="dropCategory"
            StartingNodeUrl="~/Products.aspx"
            SelectedValue='<%# Bind("CategoryId") %>'
            runat="server" />
        </div>    
        <div class="colForm">
        <asp:Label
            id="lblPrice"
            Text="Price:"
            AssociatedControlID="txtPrice"
            Runat="server" />
        <asp:RequiredFieldValidator
            id="reqPrice"
            ControlToValidate="txtPrice"
            Text="(Required)"
            Display="Dynamic"
            ValidationGroup="Add"
            Runat="server" />
        <asp:CompareValidator
            id="valPrice"
            ControlToValidate="txtPrice"
            Text="(Currency)"
            Operator="DataTypeCheck"
            Type="Currency"
            ValidationGroup="Add"
            Display="Dynamic"
            Runat="server" />        
        <div class="instructions">
            Enter the product price. 
        </div>
        <asp:TextBox
            id="txtPrice"
            Columns="5"
            Text='<%# Bind("Price") %>'
            Runat="server" />
        </div>        
        <br style="clear:both" /><br />
        <asp:Label
            id="lblDescription"
            Text="Brief Description (can include HTML):"
            AssociatedControlID="txtDescription"
            Runat="server" />
        <asp:RequiredFieldValidator
            id="reqDescription"
            ControlToValidate="txtDescription"
            Text="(Required)"
            ValidationGroup="Add"
            Runat="server" />    
        <div class="instructions">
            The brief description appears in the Products.aspx
            page and in advertisements.
        </div>
        <asp:TextBox
            id="txtDescription"
            Text='<%#Bind("Description")%>'
            TextMode="multiLine"
            Columns="40"
            Rows="2"
            Runat="server" />    
        <br /><br />
        <asp:Label
            id="lblFullDescription"
            Text="Full Description (can include HTML):"
            AssociatedControlID="txtFullDescription"
            Runat="server" />
        <div class="instructions">
            (Optional)The full description appears on the ProductDetails.aspx
            page. If you don't enter a value
            then the brief description is displayed.
        </div>
        <asp:TextBox
            id="txtFullDescription"
            Text='<%#Bind("FullDescription")%>'
            TextMode="multiLine"
            Columns="40"
            Rows="4"
            Runat="server" />    
        <br /><br />
        <asp:Label
            id="lblImage"
            Text="Image:"
            AssociatedControlID="upImage"
            Runat="server" />
        <div class="instructions">
            (Optional)Upload a product image from your hard drive. 
        </div>
        <asp:FileUpload
            id="upImage"
            Runat="server" />            
        <br /><br />
        <asp:Label
            id="lblImageAltText"
            Text="Image Alt Text:"
            AssociatedControlID="txtImageAltText"
            Runat="server" />
        <div class="instructions">
        Alternate text associated with the product image.
        </div>
        <asp:TextBox
            id="txtImageAltText"
            Text='<%#Bind("ImageAltText")%>'
            Columns="40"
            Runat="server" />
        <br /><br />         
        </div>
        <br />
        <asp:Button 
            id="btnEdit"
            Text="Update Product"
            CommandName="Update"
            ValidationGroup="Edit"
            Runat="server" />
        <asp:Button 
            id="btnCancel"
            Text="Cancel"
            CausesValidation="false"
            CommandName="Cancel"
            Runat="server" />

        </EditItemTemplate>
    </asp:FormView>

 </custom:WebWindow>



<asp:ObjectDataSource
    id="srcProducts"
    TypeName="AspNetUnleashed.Product"
    SelectMethod="Select"
    InsertMethod="Insert"
    DeleteMethod="Delete"
    OnInserted="srcProducts_Inserted"
    Runat="server" />



<asp:ObjectDataSource
    id="srcEditProducts"
    TypeName="AspNetUnleashed.Product"
    SelectMethod="Select"
    UpdateMethod="Update"
    Runat="server" OnUpdated="srcEditProducts_Updated" OnDeleted="srcEditProducts_Deleted">
    <SelectParameters>
    <asp:ControlParameter Name="Id" ControlID="grdProducts" Type="Int32" />
    </SelectParameters>
    <UpdateParameters>
    <asp:ControlParameter Name="Id" ControlID="grdProducts" Type="Int32" />
    </UpdateParameters>
</asp:ObjectDataSource>    



</asp:Content>

