<%@ Page Language="VB" MasterPageFile="~/Store.master" Title="Shopping Cart" %>

<script runat="server">
 
    Private _total As Decimal =  0 
 
    ''' <summary>
    ''' Calculate running total as rows are bound to the GridView
    ''' </summary>
    Protected Sub grdShoppingCart_RowDataBound(ByVal sender As Object, ByVal e As GridViewRowEventArgs)
        If e.Row.RowType = DataControlRowType.DataRow Then
            Dim price As Decimal = CType(DataBinder.Eval(e.Row.DataItem,"Price"), Decimal)
            Dim quantity As Integer = CType(DataBinder.Eval(e.Row.DataItem,"Quantity"), Integer)
            _total += (price * quantity)
        End If
    End Sub
 
    ''' <summary>
    ''' Show price total and check out link
    ''' </summary>
    Protected Sub grdShoppingCart_DataBound(ByVal sender As Object, ByVal e As EventArgs)
        If _total = 0 Then
            lnkCheckOut.Visible = False
        Else 
            Dim lblTotal As Label = CType(grdShoppingCart.FooterRow.FindControl("lblTotal"), Label)
            lblTotal.Text = _total.ToString("c")
        End If
    End Sub

</script>

<asp:Content ID="Content1" ContentPlaceHolderID="contentMiddle" Runat="Server">


<asp:GridView
    id="grdShoppingCart"
    DataSourceID="srcCart"
    DataKeyNames="id"
    AutoGenerateColumns="false"
    AutoGenerateDeleteButton="true"
    EmptyDataText="There are no items in your shopping cart. Login to view your saved shopping cart."
    CssClass="cartBig"
    AlternatingRowStyle-CssClass="cartAlternating"
    GridLines="none"
    ShowFooter="true"
    Runat="server" OnDataBound="grdShoppingCart_DataBound" OnRowDataBound="grdShoppingCart_RowDataBound">
    <Columns>
    
    <asp:BoundField DataField="Name" HeaderText="Product Name" />
    <asp:BoundField DataField="Quantity" HeaderText="Quantity" />
    <asp:TemplateField HeaderText="Price" FooterStyle-CssClass="cartTotalFooter">
    <ItemTemplate>
    <%# Eval("Price", "{0:c}") %>
    </ItemTemplate>
    <FooterTemplate>
    <asp:Label
        id="lblTotal"
        Runat="server" />
    </FooterTemplate>
    </asp:TemplateField>
    
    </Columns>
</asp:GridView>


<br /><br />
    
    
<asp:Hyperlink
    id="lnkCheckOut"
    Text="Check Out"
    NavigateUrl="~/CheckOut/Default.aspx"
    Runat="server" />


<asp:ObjectDataSource
    id="srcCart"
    TypeName="AspNetUnleashed.ShoppingCart"
    SelectMethod="Select"
    DeleteMethod="Delete"
    Runat="server" />


</asp:Content>

<asp:Content ContentPlaceHolderID="contentRight" runat="server" />